/*
 * 	Added by czwong
 *	for remove special character and email checking 
 */
 
/*
 * 	@Usage :	Given the field name, check if the EMAIL FIELD is EMPTY, and return the value in the Array.
 *	@Return : 	Array of string
 *	@Param
 *				f		 	: Object, the form 
 *				vFieldName 	: String, the field name to check
 *				pDisplayName	: String, the text to be displayed in the message box
 */
function validateEmailField( f, vFieldName, pDisplayName ){
	//var f = document.forms[0];
	var objTextField = eval( "f." + vFieldName );
	if ( ! isValidEmailValue( objTextField.value ) ){
		writeError( objTextField, pDisplayName );
	}
}

//==================== Email Address Related Validation =========================================================

/* 	
 * 	@Usage :	Given the Email address, test if the email is in valid (username@company.com) format.
 *	@Return :	Boolean, whether the email address in valid format.
 *	@Param :	emailStr : String, the email address to be verify.
 */
function isValidEmailValue( emailStr ){
	if ( emailStr.indexOf('@') == -1 || emailStr.indexOf('@') != emailStr.lastIndexOf('@') || emailStr.indexOf('@') + 3 > emailStr.lastIndexOf('.')
	|| emailStr.indexOf('@')  < 2 || emailStr.indexOf(".@") > -1|| emailStr.indexOf("@.") > -1 || emailStr.indexOf('.') == 0 	
	|| emailStr.substring(emailStr.lastIndexOf('.')).length < 3 || emailStr.substring(emailStr.lastIndexOf('.')).length > 4 || emailStr.indexOf("..") > -1 ){
		return false;
	}

	var numeric = "0123456789_";
	var dExt = emailStr.substring(emailStr.lastIndexOf('.')+1);
	for(i=0; i<numeric.length; i++){
		if(dExt.indexOf(numeric[i]) > -1) { return false; }
	}

	var invalidChar = "~`!#$%^&*() -=+|}{[];:?/><,'\"";
	for(i=0; i<invalidChar.length; i++){
		if(emailStr.indexOf(invalidChar[i]) > -1) { return false; }
	}
	return true;
}

//==================== Special Character Removal =========================================================
/*
 * 	@Usage :	Remove the special character in field.
 *	@Result :	Replace the special character in the value to empty "", allowed characters will remain
 *	@Param :	vObj : String, the email address to be verify.
 *				vFieldType : the type of field, currently can use textarea,phone,name,email.
 *				vSpecialCondition : the condition to be replace
 */
function removeSpecialChar(vObj,vFieldType,vSpecialCondition){
	vVal=vObj.value;
	if(vFieldType=='textarea'){
		if(vSpecialCondition && vSpecialCondition != ""){
			vVal=vVal.replace(vSpecialCondition,'');
		}else{
			vVal=vVal.replace(/[^a-zA-Z0-9,.\s]/g,'');
		}
	}else if(vFieldType=='phone'){
		if(vSpecialCondition && vSpecialCondition != ""){
			vVal=vVal.replace(vSpecialCondition,'');
		}else{
			vVal=vVal.replace(/[^0-9+-]/g,'');
		}
	}else if(vFieldType=='name'){
		if(vSpecialCondition && vSpecialCondition != ""){
			vVal=vVal.replace(vSpecialCondition,'');
		}else{
			vVal=vVal.replace(/[^a-zA-Z\s]/g,'');
		}
	}else if(vFieldType=='email'){
		if(vSpecialCondition && vSpecialCondition != ""){
			vVal=vVal.replace(vSpecialCondition,'');
		}else{
			vVal=vVal.replace(/[^a-zA-Z0-9@._]/g,'');
		}
	}else{
		if(vSpecialCondition && vSpecialCondition != ""){
			vVal=vVal.replace(vSpecialCondition,'');
		}else{
			vVal=vVal.replace(/[^a-zA-Z0-9,.\s]/g,'');
		}
	}
	vObj.value=vVal;
}