<?php
namespace moonlight\mmapi;

class emas_mysql extends \moonlight\db_mysql{
	protected $db_prefix = '';
	
	public function set_db_prefix( $p_db_prefix ){
		$this->db_prefix = $p_db_prefix;
	}
	
	public function get_db_prefix(){
		if (isset($this->db_prefix)){
			return $this->db_prefix;
		}else{
			return 'apps_emas_';
		}
	}
	

	public function function_list( $p_info=array(), $p_cond ){
		$v_limit = "";
		$v_where = "AND f.event_id!=\"\"";
		$v_table = "";
		$v_having = "";
		$v_order = "";
		
		// \U::print_arr($p_cond);
		if ( (isset($p_info['start']) && isset($p_info['max'])) ){
			$v_limit = "LIMIT ".\U::safe_sql_string($p_info['start']).", ".\U::safe_sql_string($p_info['max']);
		}
		
		if ( isset($p_info['order']) ){
			$v_order = "ORDER BY ".\U::safe_sql_string($p_info['order']);
			
			if ( isset($p_info['sort']) ){
				$v_order .= " ".\U::safe_sql_string($p_info['sort']);
			}
		}
		
		if ( isset($p_cond['ref_no']) && $p_cond['ref_no'] != "" ){
			$v_where = "AND f.ref_no='".\U::safe_sql_string($p_cond['ref_no'])."'";
		}
		if ( isset($p_cond['event_id']) && $p_cond['event_id'] != "" ){
			$v_where .= "AND f.event_id='".\U::safe_sql_string($p_cond['event_id'])."'";
		}
		if (isset($p_cond['function_code']) && $p_cond['function_code'] != ""){
			$v_where .= " AND f.function_code='".\U::safe_sql_string($p_cond['function_code'])."'";
		}
		if ( isset($p_cond['event_name']) && $p_cond['event_name'] != "" ){
			$v_table .= ", " . $this->get_db_table_prefix() . "event e";
			$v_where .= " AND e.event_name LIKE \"%".\U::safe_sql_string($p_cond['event_name'])."%\"";
			$v_where .= " AND e.event_id=f.event_id";
		}
		if ( isset($p_cond['function_name']) && $p_cond['function_name'] != "" ){
			$v_where .= " AND f.function_name LIKE \"%".\U::safe_sql_string($p_cond['function_name'])."%\"";
		}
		if (isset($p_cond['function_type']) && $p_cond['function_type'] != ""){
			$v_where .= " AND f.function_type='".\U::safe_sql_string($p_cond['function_type'])."'";
		}
		
		//Remeber to change this if need to filter by function category
		if ( isset($p_cond['function_category']) && $p_cond['function_category'] != "" ){
			$v_where .= "AND f.function_category = '".\U::safe_sql_string($p_cond['function_category'])."'";
		}
		if (isset($p_cond['date_range_start']) && $p_cond['date_range_start'] != ""){
			$v_where .= " AND f.function_date >= \"".\U::safe_sql_string($p_cond['date_range_start'])."\"";
		}
		if (isset($p_cond['date_range_end']) && $p_cond['date_range_end'] != ""){
			$v_where .= " AND f.function_date <= \"".\U::safe_sql_string($p_cond['date_range_end'])."\"";
		}
		if ( isset($p_cond['date_before']) && $p_cond['date_before'] != "" ){
			$v_where .= "AND f.function_date >= '".\U::safe_sql_string($p_cond['date_before'])."'";
		}
		if ( isset($p_cond['year']) && $p_cond['year'] != "" ){
			$v_where .= "AND YEAR(f.function_date) = '".\U::safe_sql_string($p_cond['year'])."'";
		}
		if ( isset($p_cond['month']) && $p_cond['month'] != "" ){
			$v_where .= "AND MONTH(f.function_date) = '".\U::safe_sql_string($p_cond['month'])."'";
		}
		if ( isset($p_cond['date_on']) && $p_cond['date_on'] != "" ){
			$v_where .= "AND f.function_date = '".\U::safe_sql_string($p_cond['date_on'])."'";
		}
		if ( isset($p_cond['function_invite_sent']) ){
			$v_where .= "AND f.function_invite_sent = '".\U::safe_sql_string($p_cond['function_invite_sent'])."'";
		}
		if ( isset($p_cond['event_function_list']) && $p_cond['event_function_list'] === true ){
			$v_where .= " AND f.function_status!='POSTPONE'";
		}else if ( isset($p_cond['function_status']) && $p_cond['function_status'] != "" ){
			$v_where .= " AND f.function_status = '".\U::safe_sql_string($p_cond['function_status'])."'";
		}else{
			$v_where .= " AND f.function_status = 'ACTIVE'";
		}
		if ( isset($p_cond['is_postponed_function']) && $p_cond['is_postponed_function'] != "" ){
			$v_where .= "AND f.is_postponed_function='".\U::safe_sql_string($p_cond['is_postponed_function'])."'";
		}
		if ( isset($p_cond['is_amended_function']) && $p_cond['is_amended_function'] != "" ){
			$v_where .= "AND f.is_amended_function='".\U::safe_sql_string($p_cond['is_amended_function'])."'";
		}
		if ( isset($p_cond['function_division']) && $p_cond['function_division'] != "" ){
			$v_where .= "AND f.function_division='".\U::safe_sql_string($p_cond['function_division'])."'";
		}
		if ( isset($p_cond['function_district']) && $p_cond['function_district'] != "" ){
			$v_where .= "AND f.function_district='".\U::safe_sql_string($p_cond['function_district'])."'";
		}
		if ( isset($p_cond['function_id']) && $p_cond['function_id'] != "" ){
			$v_where .= "AND f.function_id='".\U::safe_sql_string($p_cond['function_id'])."'";
		}
		if ( isset($p_cond['ag_id']) && $p_cond['ag_id'] != "" ){
			$v_where .= "AND f.ag_id='".\U::safe_sql_string($p_cond['ag_id'])."'";
		}
		if ( isset($p_cond['ad_id']) && $p_cond['ad_id'] != "" ){
			$v_where .= "AND f.ad_id='".\U::safe_sql_string($p_cond['ad_id'])."'";
		}
		
		$v_query_db_all = "SELECT ag_id,ad_id FROM ". $this->get_db_table_prefix() ."agency_dept WHERE _rec_status='SHOW'";
		$v_result_db_all = parent::execute_query($v_query_db_all);
		$v_arr_db_all = array();
		if (is_array($v_result_db_all)){
			foreach($v_result_db_all as $v_ag_db){
				if (isset($p_info['ag_id']) && isset($p_info['ad_id']) && !empty($p_info['ag_id']) && !empty($p_info['ad_id'])){
					if ($p_info['ag_id'] == $v_ag_db['ag_id'] && $p_info['ad_id'] == $v_ag_db['ad_id']){
						$v_arr_db_all[] = $this->get_db_prefix() . $v_ag_db['ag_id'] . "_" . $v_ag_db['ad_id'];
					}
				}else{
					$v_arr_db_all[] = $this->get_db_prefix() . $v_ag_db['ag_id'] . "_" . $v_ag_db['ad_id'];
				}
			}
		}
		
		if ( isset($p_cond['list_public_only']) && $p_cond['list_public_only'] == 1 ){
			$v_having .= " HAVING function_publish_to_public='1' OR event_publish_to_public='1'";
		}
		
		$v_query = '';
		foreach ($v_arr_db_all as $v_db_name){
			$v_db_select = "";
			
			if ($v_query == ""){
				$v_query .= "SELECT SQL_CALC_FOUND_ROWS f.*,";
			}else{
				$v_query .= " UNION SELECT f.*,";
			}
			$v_query .= 	"(SELECT event_name FROM {$v_db_name}.".$this->get_db_table_prefix()."event e WHERE e.event_id=f.event_id) AS event_name,
							(SELECT event_organiser FROM {$v_db_name}.".$this->get_db_table_prefix()."event e WHERE e.event_id=f.event_id) AS event_organiser,
							(SELECT event_publish_to_public FROM {$v_db_name}.".$this->get_db_table_prefix()."event e WHERE e.event_id=f.event_id) AS event_publish_to_public,
							(	SELECT kwd_value 
								FROM ".$this->get_db_table_prefix()."keyword b, ".$this->get_db_table_prefix()."keyword_lbl c 
								WHERE f.function_type=b.key_code AND docunid=kwd_code 
								AND key_title='function_type' AND kwd_lang='".\E::get('obj_curr_module')->get_lang()."'
							) AS function_locale
						FROM {$v_db_name}." . $this->get_db_table_prefix() . "function f
						$v_table
						WHERE f._rec_status=\"SHOW\"
						$v_where
						$v_having
						";
		}
		if ($v_query != ''){
			$v_query .= " $v_order  $v_limit";
			
			// echo $v_query;
			// echo $v_where;
			// exit;
			return parent::execute_query($v_query);
		}
		else
		{
			return false;
		}
	}

	

}
?>