<?php
namespace moonlight\mmapi;

class emunakahat_uat_mysql extends \moonlight\db_mysql{
	public function keyword_get($p_key_title, $p_key_code = null){
		
		$v_where = ($p_key_code == null) ? "" : " AND key_code = \"" . \U::safe_sql_string($p_key_code) . "\"";
		
		
		$v_order = 'key_display_order';
		if($p_key_title == 'division')
		{
			$v_order = 'kwd_value';
		}
		$v_query = "SELECT kwd_value, key_code,kwd_remark
						FROM " . parent::get_db_table_prefix() . "keyword k
						INNER JOIN " . parent::get_db_table_prefix() . "keyword_lbl lb
							ON lb.kwd_code = k.docunid 
							AND kwd_lang = \"".\U::safe_sql_string(\E::get('obj_curr_module')->get_lang())."\" 
							AND lb._rec_status=\"SHOW\"
						WHERE k.key_title=\"" . \U::safe_sql_string($p_key_title) . "\" AND
							  k._rec_status = \"SHOW\" 
							  ".$v_where."
						ORDER BY ".$v_order." ASC;
						";
		
		$v_result = parent::execute_query($v_query);
		
		return $v_result;
	}

	function keyword_get_codevalue($p_keyword_category, $p_empty_cell, $p_key_code){
		// Default Language
		$v_lang_info = \E::get('obj_curr_module')->get_lang();

	// Keycode filtering
		$v_key_code_filter = "";
		if(!is_null($p_key_code) AND $p_key_code!=""){
			if(is_array($p_key_code)){
				$v_key_code_filter = " AND key_code IN ('". implode("','", $p_key_code ) ."') ";
			}else{
				$v_key_code_filter = " AND key_code = '" . \U::safe_sql_string( $p_key_code ) . "'";
			}
		}

		unset($v_key_arr);
		$v_key_arr = NULL;
		
		$v_query = 	"SELECT 
                    docunid,
                    key_code,
                    kwd_value
                  FROM " . $this->get_db_table_prefix() . "keyword k 
                  LEFT JOIN " . $this->get_db_table_prefix() . "keyword_lbl l 
                  ON k.docunid = l.kwd_code 
                  WHERE k._rec_status = \"SHOW\" 
                  AND key_title=\"" . \U::safe_sql_string( $p_keyword_category ) . "\"
                  AND kwd_lang=\"" . \U::safe_sql_string( $v_lang_info ) . "\"
                  " . $v_key_code_filter . "
                  ORDER BY key_display_order ASC
                ";
		$v_result = parent::execute_query($v_query);
		
		if($v_result && is_array($v_result)){
			if($p_empty_cell){
				$v_key_arr[''] = \E::get( 'obj_curr_module_lang')->get('FIELD_COMBO_DEFAULT');
			}

			foreach($v_result as $v_key=>$v_value){
				$v_key_arr[$v_result[$v_key]['key_code']] = $v_result[$v_key]['kwd_value'];
			}
		}	
		
		return $v_key_arr;
	}
	
/*******************
Emunakahat functions
********************/
	//24/8/2012
	//To get the timetable of the course
	public function course_timetable_get($p_info){
		$v_cond="";
		if(isset($p_info['location']) && $p_info['location']!=''){
			$v_cond=" AND course_location =\"".\U::safe_sql_string($p_info['location'])."\"";
		}
		
		$v_query = "
			SELECT * FROM ". $this->get_db_table_prefix() ."course_timetable WHERE 
			_rec_status = 'SHOW' 
			AND course_start_date > '".\U::safe_sql_string($p_info['today'])."'
			AND course_quota > course_current_reg
			".$v_cond."
		";
		
		return $v_result = parent::execute_query($v_query);
	}
	
	//27/8/2012
	//To get the specific course
	public function get_course($p_info){
		$v_query = "
			SELECT d.*,
			(SELECT kwd_value FROM ".$this->get_db_table_prefix()."keyword g, ".$this->get_db_table_prefix()."keyword_lbl f , ".$this->get_db_table_prefix()."course_timetable d WHERE d.course_location=g.key_code AND docunid=kwd_code AND key_title='division' AND d.course_id= '".\U::safe_sql_string($p_info['course_id'])."' AND kwd_lang='".\E::get('obj_curr_module')->get_lang()."') AS course_division_locale 
			
			FROM ". $this->get_db_table_prefix() ."course_timetable d WHERE d.course_id = '".\U::safe_sql_string($p_info['course_id'])."' 
			AND _rec_status = 'SHOW'
		";
		return $v_result = parent::execute_query($v_query);
	}

	//29/8/2012
	public function update_course_number($v_course_id){
		$v_query = "UPDATE ". $this->get_db_table_prefix() ."course_timetable SET course_current_reg = course_current_reg + 1 WHERE course_id = '".\U::safe_sql_string($v_course_id)."'
		";
		
		return $v_result = parent::execute_query($v_query);
	}
	
	

	public function insert_attachment_reg($p_info){
		$v_query = "
			INSERT INTO ". $this->get_db_table_prefix() ."attachment_info
			SET
			reg_id = \"".\U::safe_sql_string($p_info['reg_id'])."\",
			att_field = \"".\U::safe_sql_string($p_info['att_field'])."\",
			_rec_created_by = \"".\U::safe_sql_string($p_info['_rec_created_by'])."\",
			_rec_created_on = \"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\",
			att_name = \"".\U::safe_sql_string($p_info['att_name'])."\",
			att_type = \"".\U::safe_sql_string($p_info['att_type'])."\",
			att_size = \"".\U::safe_sql_string($p_info['att_size'])."\",
			att_location = \"".\U::safe_sql_string($p_info['att_location'])."\",
			att_id = \"".\U::safe_sql_string($p_info['att_id'])."\",
			_rec_modified_by = \"".\U::safe_sql_string($p_info['_rec_modified_by'])."\",
			_rec_modified_on = \"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\"
		";
		return $result = parent::execute_query($v_query);
	}
	
	
	
	public function get_course_reg_detail($p_info){
		$v_query = "
			SELECT a.*,b.*
			FROM " . $this->get_db_table_prefix() . "reg_course a

			LEFT JOIN " . $this->get_db_table_prefix() . "course_applicant b
			ON a.course_reg_id = b.reg_id
			WHERE a.course_reg_id = '".\U::safe_sql_string($p_info['course_reg_id'])."'
			AND a._rec_status = 'SHOW'
			AND b._rec_status = 'SHOW'
		";
		return $v_result=parent::execute_query($v_query);
	}
	
	public function register_course($p_info){
		$v_apps_obj = new \moonlight\mmapi\emunakahat_branch();
		$v_course_info = $v_apps_obj->get_course($p_info);
		// return $p_info;
		//Finds if this id is already registered - ACTIVATED
		$block_marker = 0;
		$block_query = "SELECT a.*,b.* FROM " . $this->get_db_table_prefix() . "course_applicant a, 
			" . $this->get_db_table_prefix() . "reg_course b
			WHERE 
			a._rec_status = 'SHOW'
			AND b._rec_status = 'SHOW'
			AND a.reg_id = b.course_reg_id
			AND a.psn_identification = \"".\U::safe_sql_string($p_info['psn_identification'])."\"
			ORDER BY b._rec_created_on DESC, b._rec_modified_on DESC
			LIMIT 1
		";
		$v_search_duplicate = parent::execute_query($block_query);

		$v_course_module= $v_apps_obj->keyword_get('course_module');
		$v_course_count = count($v_course_module);
		
		if(is_array($v_search_duplicate[0])){
			$p_search['course_reg_id'] = $v_search_duplicate[0]['reg_id'];
			$v_search_dup = $v_apps_obj->get_course_reg_detail($p_search);
			if(is_array($v_search_dup[0])){
				$v_search_dup_result = $v_search_dup[0];
				
				$v_course_info = $v_apps_obj->get_course($p_info['course_id']);
				
				$v_pass_percent = \E::get('obj_kernel_config' )->get('course_pass_req/percentage');
				$v_pass_course = \E::get('obj_kernel_config' )->get('premarital_course/minimum_passing_course');
				$v_grace_period = \E::get('obj_kernel_config' )->get('premarital_course/grace_period');
				$v_var['pass_percent']=$v_pass_percent;
				//If already attended the course
				if(isset($v_search_dup_result['course_attend'])&&$v_search_dup_result['course_attend']=='1'
					&& isset($v_search_dup_result['course_module_count']) && $v_search_dup_result['course_module_count']>=$v_pass_course){
					//If passed 100%
					$block_marker = 1;
				}else if(isset($v_search_dup_result['course_attend'])&&$v_search_dup_result['course_attend']=='1'
					&& isset($v_search_dup_result['course_module_count']) && $v_search_dup_result['course_module_count']<$v_pass_course){
					//==If attend but not fullfill all course 
					$v_date_diff = \I::check_date_diff($v_today,$v_course_info[0]['course_end_date']);
					if($v_date_diff >= 0 && $v_date_diff< $v_grace_period ){//==todays date is less than a week frm the closing date
						$block_marker = 1;
					}
				}
			}
		}
		if($block_marker == 1){
			$error['message']='ID';
			return $error;
		}

		$p_type='premarital_course';
		if(isset($p_info['course_district']) && ($p_info['course_district'] == 'K(1)' || $p_info['course_district'] == 'H(1)')){
			$p_division = $p_info['course_district'];
		}else{
			$p_division = $p_info['course_location'];
		}
		$p_info['_rec_count'] = $this->get_next_number($p_type,$p_division);
		$v_new_number = $this->update_number($p_type,$p_division);
		
		$v_length = 6 - strlen($p_info['_rec_count']);
		$v_zero_pad = '';
		for($padding=0;$padding<$v_length;$padding++)
		{
			$v_zero_pad .= '0';
		}
		$p_info['course_count'] = $v_zero_pad.$p_info['_rec_count'];
		$p_info['course_code']=$p_info['course_code_type'].'/'.$p_division.'/'.$p_info['course_year'].'/'.$p_info['course_count'];
		
		$v_query = "
			INSERT INTO ". $this->get_db_table_prefix() ."reg_course SET
			course_id = \"".\U::safe_sql_string($p_info['course_id'])."\",
			course_code = \"".\U::safe_sql_string($p_info['course_code'])."\",
			psn_title = \"".\U::safe_sql_string($p_info['psn_title'])."\",
			course_year = \"".\U::safe_sql_string($p_info['course_year'])."\",
			_rec_created_by = \"".\U::safe_sql_string($p_info['current_usr_id'])."\",
			_rec_created_on = \"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\",
			_rec_modified_by = \"".\U::safe_sql_string($p_info['current_usr_id'])."\",
			_rec_modified_on = \"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\",
			SESSID = \"".\U::safe_sql_string($p_info['PHPSESSID'])."\",
			_rec_status = 'SHOW'
			
		";
		$v_result = parent::execute_query($v_query);
		return parent::get_last_insert_id();
	}
	
	public function load_course($p_info){
		$v_query = "SELECT d.*,a.*,
		(SELECT kwd_value FROM ".$this->get_db_table_prefix()."keyword g, ".$this->get_db_table_prefix()."keyword_lbl f , ".$this->get_db_table_prefix()."course_applicant a WHERE a.psn_address_home_division=g.key_code AND docunid=kwd_code AND key_title='division' AND a.reg_id = '".\U::safe_sql_string($p_info['course_reg_id'])."' AND kwd_lang='".\E::get('obj_curr_module')->get_lang()."') AS home_division_locale 
		FROM ". $this->get_db_table_prefix() ."reg_course d
		
		LEFT JOIN  ". $this->get_db_table_prefix() ."course_applicant a
		ON d.course_reg_id = a.reg_id
		
		WHERE course_reg_id =\"".\U::safe_sql_string($p_info['course_reg_id'])."\"
		AND d._rec_status=\"SHOW\"
		AND a._rec_status=\"SHOW\"
		AND d.course_reg_id = a.reg_id
		";
		$v_result = parent::execute_query($v_query);
		return $v_result;
	}
	
	public function get_course_list($p_info,$p_cond){
		$v_limit='';
		$v_where='';
		if ( (isset($p_info['start']) && isset($p_info['max'])) ){
			$v_limit = "LIMIT ".\U::safe_sql_string($p_info['start']).", ".\U::safe_sql_string($p_info['max']);
		}
		$v_order = "";
		if ( isset($p_info['order']) ){
			$v_order = "ORDER BY ".\U::safe_sql_string($p_info['order']);
			
			if ( isset($p_info['sort']) ){
				$v_order .= " ".\U::safe_sql_string($p_info['sort']);
			}
		}
		
		if(isset($p_cond['course_start_date'])&&$p_cond['course_start_date']!=''){
			$v_where .=" AND course_start_date >= '".\U::safe_sql_string(parent::to_db_datetime($p_cond['course_start_date']))."' ";
		}
		
		if(isset($p_cond['course_end_date'])&&$p_cond['course_end_date']!=''){
			$v_where .=" AND course_end_date <= '".\U::safe_sql_string(parent::to_db_datetime($p_cond['course_end_date']))."' ";
		}
		
		if(isset($p_cond['course_location'])&&$p_cond['course_location']!=''){
			$v_where .=" AND course_location = '".\U::safe_sql_string($p_cond['course_location'])."'";
		}

		if(isset($p_cond['is_special_course'])&&$p_cond['is_special_course']!=''){
			$v_where .=" AND is_special_course = '".\U::safe_sql_string($p_cond['is_special_course'])."'";
		}
		
		if(isset($p_cond['course_quota_status'])&&$p_cond['course_quota_status']!=''){
			$p_cond['course_quota_status']=strtoupper($p_cond['course_quota_status']);
			if($p_cond['course_quota_status']=='FULL'){
				$v_where .=" AND course_quota - course_current_reg <= 0 ";
			}else if($p_cond['course_quota_status']=='AVAILABLE'){
				$v_where .=" AND course_quota - course_current_reg > 0 ";
			}
		}
		
		if(isset($p_cond['course_future_passed'])&&$p_cond['course_future_passed']!=''){
			if(!isset($p_cond['course_start_date'])||$p_cond['course_start_date']==''||!isset($p_cond['course_end_date'])||$p_cond['course_end_date']==''){
				if(isset($p_cond['today'])&&$p_cond['today']!=''){
					if($p_cond['course_future_passed']=='FUTURE'){
						$v_where .= " AND course_start_date >= '".\U::safe_sql_string($p_cond['today'])."'";
						// $v_where .= " AND course_end_date > '".\U::safe_sql_string($p_cond['today'])."'";
					}
					if($p_cond['course_future_passed']=='PASSED'){
						$v_where .= " AND course_end_date <= '".\U::safe_sql_string($p_cond['today'])."'";
						// $v_where .= " AND course_start_date < '".\U::safe_sql_string($p_cond['today'])."'";
					}
				}
			}
		}
		
		if(isset($p_cond['main_menu'])&&$p_cond['main_menu']=='MAIN_MENU'){
			$v_where .= "AND DATEDIFF(NOW(),_rec_created_on) < '7'";
		}
		
		if(isset($p_cond['main_menu'])&&$p_cond['main_menu']=='CURRENT_WEEK'){
			$v_where .= "AND DATEDIFF(course_start_date,NOW()) < '7' AND DATEDIFF(course_start_date,NOW()) >= '0' ";
		}
		
		$v_query = "SELECT SQL_CALC_FOUND_ROWS * 
		FROM ".$this->get_db_table_prefix()."course_timetable WHERE _rec_status='SHOW'
		$v_where
		$v_order
		$v_limit
		";
		return parent::execute_query($v_query);
	}
	
	public function course_list_total(){
		$v_result = parent::execute_query("SELECT FOUND_ROWS()");
		return $v_result[0]['FOUND_ROWS()'];
	}
	
	/*
   * Function to retrieve the list of user
   */
	public function user_acl_list( $p_order=null, $p_start = null, $p_num_of_rec = null,$p_publish=null, $p_cat=null){
    
		$v_lang_info = \E::get('obj_curr_module')->get_lang();
	
		//For where
		$v_where = '';
		if(isset($p_cat['filter'])&&$p_cat['filter']=='PENDAFTAR'){
		//HARD CODED - MIGHT NEED TO CHANGE
		$v_where .= " AND group_id = '12' ";
		}
	
		if(isset($p_cat['filter'])&&$p_cat['filter']=='JURUNIKAH'){
		//HARD CODED - MIGHT NEED TO CHANGE
			$v_where .= " AND group_id = '11' ";
		}
		
		if(isset($p_cat['division'])&&$p_cat['division']!=''){
			$v_where .= " AND division_id = '".\U::safe_sql_string($p_cat['division'])."' ";
		}
	
		// ORDER BY - Coding
		$v_order_by = '';
		if($p_order != null){
			foreach($p_order as $v_value){
				if($v_order_by == '') $v_order_by = ' ORDER BY '.$v_value['order_by'].' '.$v_value['sort_by'];
				else $v_order_by .= ', ' . $v_value['order_by'] . ' ' .$v_value['sort_by'];
			}
		}
		
		// LIMIT - Coding
		$v_limit = '';
		if($p_start !== null && $p_num_of_rec !== null){
			$v_limit = ' LIMIT ' . \U::safe_sql_string($p_start) . ', ' . \U::safe_sql_string($p_num_of_rec);
			
		}
		
		$v_query = 	"SELECT usr_id,
								kwd_value,
								division_id,
								group_id,
								user_convert_role,
								user_letter_role,
								user_super_role,
								u.*
		  FROM " . $this->get_db_table_prefix() . "acl_user_group u
		  LEFT JOIN " . $this->get_db_table_prefix() . "acl_group_lbl l
		  ON u.group_id = l.kwd_code
		  WHERE u._rec_status = \"SHOW\"
		  $v_where
		  AND l.kwd_lang=\"".$v_lang_info."\" " . $v_order_by . $v_limit;
		$v_result = parent::execute_query($v_query);
		if($v_result && is_array($v_result)){
			foreach($v_result as $v_key=>$v_value){
				$v_result[$v_key]['_rec_modified_on'] = parent::__to_display_date($v_result[$v_key]['_rec_modified_on']);
			}
		}

		return $v_result;
	}
	
	public function user_acl_get( $p_id ){
		$v_key = isset($v_key)?$vkey:0;
		$v_lang_info = \E::get('obj_curr_module')->get_lang();
    
		$v_query = 	"SELECT 
                    *
                  FROM " . $this->get_db_table_prefix() . "acl_user_group 
                  WHERE _rec_status = \"SHOW\" 
                  AND usr_id=\"" . \U::safe_sql_string( $p_id ) . "\"
                ";
		$v_result = parent::execute_query($v_query);
		if($v_result && is_array($v_result)){
			$v_result[$v_key]['_rec_modified_on'] = parent::__to_display_date($v_result[$v_key]['_rec_modified_on']);
		}

		return $v_result;
	}
  

	public function nikah_add($p_info){
		if (isset($p_info['reg_type']) && $p_info['reg_type'] != ""){
			$v_insert .= "reg_type=\"".\U::safe_sql_string($p_info['reg_type'])."\", ";
		}
		
		if (isset($p_info['male_underage']) && $p_info['male_underage'] != ""){
			$v_insert .= "male_underage=\"".\U::safe_sql_string($p_info['male_underage'])."\", ";
		}
		
		if (isset($p_info['female_underage']) && $p_info['female_underage'] != ""){
			$v_insert .= "female_underage=\"".\U::safe_sql_string($p_info['female_underage'])."\", ";
		}
		
		if (isset($p_info['wali_enggan']) && $p_info['wali_enggan'] != ""){
			$v_insert .= "wali_enggan=\"".\U::safe_sql_string($p_info['wali_enggan'])."\", ";
		}
		
		if (isset($p_info['wali_hakim']) && $p_info['wali_hakim'] != ""){
			$v_insert .= "wali_hakim=\"".\U::safe_sql_string($p_info['wali_hakim'])."\", ";
		}
		
		if (isset($p_info['poligami']) && $p_info['poligami'] != ""){
			$v_insert .= "poligami=\"".\U::safe_sql_string($p_info['poligami'])."\", ";
		}
		
		if (isset($p_info['cerai_sebelum_jima']) && $p_info['cerai_sebelum_jima'] != ""){
			$v_insert .= "cerai_sebelum_jima=\"".\U::safe_sql_string($p_info['cerai_sebelum_jima'])."\", ";
		}
		
		if (isset($p_info['PHPSESSID']) && $p_info['PHPSESSID'] != ""){
			$v_insert .= "PHPSESSID=\"".\U::safe_sql_string($p_info['PHPSESSID'])."\", ";
		}
		
		if (isset($p_info['reg_status']) && $p_info['reg_status'] != ""){
			$v_insert .= "reg_status=\"".\U::safe_sql_string($p_info['reg_status'])."\", ";
		}
		
		if (isset($p_info['_rec_source']) && $p_info['_rec_source'] != ""){
			$v_insert .= "_rec_source=\"".\U::safe_sql_string($p_info['_rec_source'])."\", ";
		}		
		
		$v_query = "INSERT INTO " . $this->get_db_table_prefix() . "registration_nikah SET
					{$v_insert}
				_rec_status = \"SHOW\",
				_rec_modified_by = \"".\U::safe_sql_string($p_info['current_usr_id'])."\",
				_rec_modified_on = \"".\U::safe_sql_string(parent::to_db_datetime($p_info['current_datetime']))."\",
				_rec_created_by = \"".\U::safe_sql_string($p_info['current_usr_id'])."\",
				_rec_created_on = \"".\U::safe_sql_string(parent::to_db_datetime($p_info['current_datetime']))."\"
			";
			
		$v_success = parent::execute_query($v_query);
		$p_info['reg_id'] = parent::get_last_insert_id();
		return $p_info['reg_id'];
	}
	
	public function nikah_edit($p_info){
		$v_update = '';
		if (isset($p_info['reg_type']) == true && $p_info['reg_type'] != ""){
			$v_update .= "reg_type=\"".\U::safe_sql_string($p_info['reg_type'])."\", ";
		}
		
		if (isset($p_info['male_underage']) == true && $p_info['male_underage'] != ""){
			$v_update .= "male_underage=\"".\U::safe_sql_string($p_info['male_underage'])."\", ";
		}
		
		if (isset($p_info['female_underage']) == true && $p_info['female_underage'] != ""){
			$v_update .= "female_underage=\"".\U::safe_sql_string($p_info['female_underage'])."\", ";
		}
		
		if (isset($p_info['wali_enggan']) == true && $p_info['wali_enggan'] != ""){
			$v_update .= "wali_enggan=\"".\U::safe_sql_string($p_info['wali_enggan'])."\", ";
		}
		
		if (isset($p_info['wali_hakim']) == true && $p_info['wali_hakim'] != ""){
			$v_update .= "wali_hakim=\"".\U::safe_sql_string($p_info['wali_hakim'])."\", ";
		}
		
		if (isset($p_info['poligami']) == true && $p_info['poligami'] != ""){
			$v_update .= "poligami=\"".\U::safe_sql_string($p_info['poligami'])."\", ";
		}
		
		if (isset($p_info['cerai_sebelum_jima']) == true && $p_info['cerai_sebelum_jima'] != ""){
			$v_update .= "cerai_sebelum_jima=\"".\U::safe_sql_string($p_info['cerai_sebelum_jima'])."\", ";
		}
		
		if (isset($p_info['wali_relationship']) == true && $p_info['wali_relationship'] != ""){
			$v_update .= "wali_relationship=\"".\U::safe_sql_string($p_info['wali_relationship'])."\", ";
		}
		
		if (isset($p_info['wali_relation_detail']) == true && $p_info['wali_relation_detail'] != ""){
			$v_update .= "wali_relation_detail=\"".\U::safe_sql_string($p_info['wali_relation_detail'])."\", ";
		}
		
		if (isset($p_info['wali_relation_other']) == true && $p_info['wali_relation_other'] != ""){
			$v_update .= "wali_relation_other=\"".\U::safe_sql_string($p_info['wali_relation_other'])."\", ";
		}
		
		if (isset($p_info['wali_agreement']) == true && $p_info['wali_agreement'] != ""){
			$v_update .= "wali_agreement=\"".\U::safe_sql_string($p_info['wali_agreement'])."\", ";
		}
		
		if (isset($p_info['female_guardian_relation']) == true && $p_info['female_guardian_relation'] != ""){
			$v_update .= "female_guardian_relation=\"".\U::safe_sql_string($p_info['female_guardian_relation'])."\", ";
		}
		
		if (isset($p_info['male_guardian_relation']) == true && $p_info['male_guardian_relation'] != ""){
			$v_update .= "male_guardian_relation=\"".\U::safe_sql_string($p_info['male_guardian_relation'])."\", ";
		}
		
		$v_query = "UPDATE " . $this->get_db_table_prefix() . "registration_nikah SET
				{$v_update}
			_rec_modified_by = \"".\U::safe_sql_string($p_info['current_usr_id'])."\",
			_rec_modified_on = \"".\U::safe_sql_string(parent::to_db_datetime($p_info['current_datetime']))."\"
			WHERE
			reg_id = \"".\U::safe_sql_string($p_info['reg_id'])."\"
		";
		
		$v_result = parent::execute_query($v_query);
		if ($v_result){
			return $p_info['reg_id'];
		}else {
			return false;
		}
	}
	
	public function get_extra_attach_list($reg_id){
		$v_query ="
			SELECT * FROM ".$this->get_db_table_prefix()."extra_attachment
			WHERE 
			_rec_status = 'SHOW'
			AND reg_id =  \"".\U::safe_sql_string($reg_id)."\"
			";
		return $v_result = parent::execute_query($v_query);
	}
	
	public function register_finalize($p_info){
		$p_type='nikah';
		$p_division = $p_info['akad_nikah_address_division'];
		$p_info['_rec_count'] = $this->get_next_number($p_type,$p_division);
		$v_new_number = $this->update_number($p_type,$p_division);
		// exit;
		$v_length = 6 - strlen($p_info['_rec_count']);
		$v_zero_pad = '';
		for($padding=0;$padding<$v_length;$padding++){
			$v_zero_pad .= '0';
		}
		
		$p_info['_rec_count'] = $v_zero_pad.$p_info['_rec_count'];
		
		$v_set = "";
		$v_checking = "SELECT * FROM ".$this->get_db_table_prefix().
			"registration_nikah WHERE reg_id = \"".\U::safe_sql_string($p_info['reg_id'])."\"
		";
		
		$v_checking_result = parent::execute_query($v_checking);
		
		if(is_array($v_checking_result)&&isset($v_checking_result[0]['reg_status'])&&$v_checking_result[0]['reg_status']=='AMENDED'){
			$v_set .= "reg_status = 'AMENDED', ";
			
		}else{
			$v_set .= "reg_status = 'NEW_APPLICATION', ";
			$v_set .= "_rec_year = \"".\U::safe_sql_string($p_info['_rec_year'])."\", ";
			$v_set .= "_rec_count = '".\U::safe_sql_string($p_info['_rec_count'])."',";
			$v_set .= "reg_case_no = '".\U::safe_sql_string($p_info['reg_case_no'])."',"; 
		}
		
		$v_query = "UPDATE ".$this->get_db_table_prefix()."registration_nikah 
			SET 
			$v_set
			_rec_source = 'WEB',
			_rec_modified_by = \"".\U::safe_sql_string($p_info['current_usr_id'])."\",
			_rec_modified_on = \"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\"
			WHERE 
			reg_id = \"".\U::safe_sql_string($p_info['reg_id'])."\"
		";
		$v_result = parent::execute_query($v_query);
		
		return $v_result;
	}
	
	public function get_register_nikah($v_reg_id){
		$v_query ="
			SELECT a.*,
			(SELECT kwd_value FROM ".$this->get_db_table_prefix()."keyword e, ".$this->get_db_table_prefix()."keyword_lbl f WHERE a.reg_status=e.key_code AND docunid=kwd_code AND key_title='reg_status' AND kwd_lang='".\E::get('obj_curr_module')->get_lang()."') AS reg_status_locale
			FROM ".$this->get_db_table_prefix()."registration_nikah a
			WHERE
			a._rec_status = 'SHOW'
			AND a.reg_id = ".\U::safe_sql_string($v_reg_id)."
		";
		return $v_result = parent::execute_query($v_query);
	}
	
	public function attach_list($v_reg_id){
		$v_query = "SELECT * FROM ".$this->get_db_table_prefix()."attachment_info
		WHERE reg_id = \"".\U::safe_sql_string($v_reg_id)."\"
		AND _rec_status='SHOW'
		";
		return $v_result = parent::execute_query($v_query);
	}
	
	//To add attachment
	public function attach_add($p_info){
		$v_query = "INSERT INTO ".$this->get_db_table_prefix()."attachment_info 
			SET 
			reg_id = \"".\U::safe_sql_string($p_info['reg_id'])."\",
			att_field = \"".\U::safe_sql_string($p_info['att_field'])."\",
			_rec_modified_by = \"".\U::safe_sql_string($p_info['current_usr_id'])."\",
			_rec_modified_on = \"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\",
			_rec_created_by = \"".\U::safe_sql_string($p_info['current_usr_id'])."\",
			_rec_created_on = \"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\"
		";
		parent::execute_query($v_query);
		$p_table_info['att_id'] = parent::get_last_insert_id();
		$p_table_info['tbl_name'] = $this->get_db_table_prefix() . "att";
		$p_table_info['tbl_id'] = $p_info['reg_id'].'_'.parent::get_last_insert_id();
		$p_table_info['_rec_created_by'] = \U::safe_sql_string($p_info['current_usr_id']);
		
		return $p_table_info;
	}
	
	//To edit attachment
	public function attach_edit($p_info){
		$v_query = "UPDATE ".$this->get_db_table_prefix()."attachment_info 
			SET 
			att_name = \"".\U::safe_sql_string($p_info['name'])."\",
			att_type = \"".\U::safe_sql_string($p_info['type'])."\",
			att_size = \"".\U::safe_sql_string($p_info['size'])."\",
			att_location = \"".\U::safe_sql_string($p_info['location'])."\",
			att_id = \"".\U::safe_sql_string($p_info['id'])."\",
			_rec_modified_by = \"".\U::safe_sql_string($p_info['current_usr_id'])."\",
			_rec_modified_on = \"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\"
			WHERE reg_id = \"".\U::safe_sql_string($p_info['reg_id'])."\"
			AND att_field = \"".\U::safe_sql_string($p_info['field'])."\"
		";
		parent::execute_query($v_query);
		
		$v_get_last_edit_id_query = "
			SELECT id,att_field FROM ".$this->get_db_table_prefix()."attachment_info 
			ORDER BY _rec_modified_on DESC 
			LIMIT 1
			";
		$v_last_id = parent::execute_query($v_get_last_edit_id_query);
		// \U::print_arr($v_last_id['id']);
		return $v_last_id;
	}
	
	public function attach_del($p_info){
		$v_query = "UPDATE ".$this->get_db_table_prefix()."attachment_info 
			SET 
			_rec_status = 'DELETED',
			_rec_deleted_by = \"".\U::safe_sql_string($p_info['current_usr_id'])."\",
			_rec_deleted_on = \"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\"
			WHERE 
			id = \"".\U::safe_sql_string($p_info['id'])."\"
		";
		return $v_result = parent::execute_query($v_query);
	}
	
	public function get_akad_nikah_info($reg_id){
		$v_query = "SELECT * FROM ".$this->get_db_table_prefix()."reg_akad_nikah
			WHERE reg_id = '".\U::safe_sql_string($reg_id)."' 
			AND _rec_status = 'SHOW'
		";
		return $v_result = parent::execute_query($v_query);
	}
	
	public function district_list($p_info){
		$v_district = $this->keyword_get('district_'.\U::safe_sql_string($p_info));

		return $v_district;
	}
	
	public function register_add_akad_nikah($p_info){
		$v_where = "";
		$v_set = "";
		$v_checking = "SELECT * FROM ". $this->get_db_table_prefix() .
			"reg_akad_nikah WHERE
			reg_id = \"".\U::safe_sql_string($p_info['reg_id'])."\"
			";
		$v_exist = parent::execute_query($v_checking);
		if(!is_array($v_exist)){
			$v_action = "INSERT INTO ";
			$v_set .= "
				_rec_created_by = \"".\U::safe_sql_string($p_info['current_usr_id'])."\",
				_rec_created_on = \"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\",
			";
		}else{
			$v_action='UPDATE ';
			$v_where.=" WHERE reg_id = \"".\U::safe_sql_string($p_info['reg_id'])."\"";
		}
	
		$v_query = $v_action. $this->get_db_table_prefix() .
			"reg_akad_nikah SET
			reg_id = \"".\U::safe_sql_string($p_info['reg_id'])."\",
			jurunikah_name = '".\U::safe_sql_string($p_info['jurunikah_name'])."',
			jurunikah_id = '".\U::safe_sql_string($p_info['jurunikah_id'])."',
			jurunikah_tauliah = '".\U::safe_sql_string($p_info['jurunikah_tauliah'])."',
			jurunikah_identity = '".\U::safe_sql_string($p_info['jurunikah_identity'])."',
			akad_nikah_date = '".\U::safe_sql_string($p_info['akad_nikah_date'])."',
			mas_kahwin = '".\U::safe_sql_string($p_info['mas_kahwin'])."',
			akad_nikah_address = '".\U::safe_sql_string($p_info['akad_nikah_address'])."',
			akad_nikah_address_postcode = '".\U::safe_sql_string($p_info['akad_nikah_address_postcode'])."',
			akad_nikah_address_division = '".\U::safe_sql_string($p_info['akad_nikah_address_division'])."',
			akad_nikah_address_district = '".\U::safe_sql_string($p_info['akad_nikah_address_district'])."',
			akad_nikah_address_country = '".\U::safe_sql_string($p_info['akad_nikah_address_country'])."',
			bacaan_taliq = '".\U::safe_sql_string($p_info['bacaan_taliq'])."',
			akad_nikah_state = '".\U::safe_sql_string($p_info['akad_nikah_state'])."',
			jurunikah_wali = '".\U::safe_sql_string($p_info['jurunikah_wali'])."',
			$v_set
			_rec_modified_by = \"".\U::safe_sql_string($p_info['current_usr_id'])."\",
			_rec_modified_on = \"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\"
			
			$v_where
			";
		$result = parent::execute_query($v_query);
		return $result;
	}
	
	//==eMunakahat Applicant Start
	public $applicant_table;
	public $applicant_field=array();

	//use this to change table
	public function applicant_set_table($p_tablename='applicant'){
    if($p_tablename == 'applicant' 
		|| $p_tablename == 'nikah_applicant' 
		|| $p_tablename == 'nikah_ln_applicant' 
		|| $p_tablename == 'cerai_applicant'
		|| $p_tablename == 'ruju_applicant'
		|| $p_tablename == 'course_applicant'
		){
		
			$this->applicant_table=$p_tablename;
			
			$v_field=array(
			'id',
			'reg_id',
			'psn_role',
			'psn_id',
			'psn_login_id',
			'psn_login_password',
			'psn_identification',
			'psn_other_identification',
			'psn_other_id_type',
			'psn_name',
			'psn_ori_religion',
			'psn_ori_religion_detail',
			'psn_date_of_conversion',
			'psn_place_of_conversion',
			'psn_ethnic',
			'psn_ethnic_detail',
			'psn_dob',
			'psn_age',
			'psn_gender',
			'psn_marital_status',
			'psn_nationality',
			'psn_nationality_detail',
			'psn_address_home',
			'psn_address_home_postcode',
			'psn_address_home_division',
			'psn_address_home_state',
			'psn_address_home_country',
			'psn_address_postal',
			'psn_address_postal_postcode',
			'psn_address_postal_division',
			'psn_address_postal_state',
			'psn_address_postal_country',
			'psn_address_office',
			'psn_address_office_postcode',
			'psn_address_office_division',
			'psn_address_office_state',
			'psn_address_office_country',
			'psn_highest_education',
			'psn_highest_education_detail',
			'psn_occupation',
			'psn_occupation_other',
			'psn_contact_type',
			'psn_contact',
			'psn_email',
			'psn_ikrar',
			'psn_access',
			'psn_company',
			'psn_approve_status',
			'_rec_created_by',
			'_rec_created_on',	
			'_rec_modified_by',
			'_rec_modified_on',	
			'_rec_deleted_by',
			'_rec_deleted_on',
			'_rec_status',
			'psn_newsletter'
			);
			if($p_tablename=='applicant'){
				unset($v_field[0]);
				unset($v_field[1]);
				unset($v_field[2]);
			}
			if($p_tablename=='nikah_applicant'){
				unset($v_field[4]);
				unset($v_field[5]);
			}
			$this->applicant_field=$v_field;
		}
	}
	
	public function applicant_process_field($p_value,$p_crud){
		if($p_crud=='add'){
		}
		//edit
		if($p_crud=='edit'){
		}
		
		//all
		if(isset($p_value['psn_login_password']) && $p_value['psn_login_password']!=''){
			$p_value['psn_login_password']=md5($p_value['psn_login_password']);
		}
		if(isset($p_value['psn_dob']) && $p_value['psn_dob']!=''){
			$p_value['psn_dob']=\E::get( 'obj_curr_module')->__to_system_date($p_value['psn_dob'],'date');
		}
		if(isset($p_value['psn_date_of_conversion']) && $p_value['psn_date_of_conversion']!=''){
			$p_value['psn_date_of_conversion']=\E::get( 'obj_curr_module')->__to_system_date($p_value['psn_date_of_conversion'],'date');
		}
	}
	
	public function applicant_add($p_value){
		if($this->applicant_table==''){
			$this->applicant_set_table();
		}
		$v_ary_field=$this->applicant_field;	
		
		$this->applicant_process_field($p_value,'add');
		
		foreach($v_ary_field as $v_key=>$v_each){
			if(isset($p_value[$v_each]) && $p_value[$v_each]!=''){
				$v_field[]=$v_each;
				$v_value[]="\"".\U::safe_sql_string($p_value[$v_each])."\"";
				$v_update[]=$v_each."=\"".\U::safe_sql_string($p_value[$v_each])."\"";
			}
		}
		
		$v_query="INSERT INTO " . $this->get_db_table_prefix().$this->applicant_table." 
							(".implode(',',$v_field).") VALUES (".implode(',',$v_value).")
							ON DUPLICATE KEY UPDATE ".implode(',',$v_update)."
							";
		$v_result = parent::execute_query($v_query);
		$v_id=parent::get_last_insert_id();
		$this->applicant_set_table();//reset
		return $v_id;
	}

	public function applicant_edit($p_value,$p_equal){
		if($this->applicant_table==''){
			$this->applicant_set_table();
		}
		$v_ary_field=$this->applicant_field;
		
		foreach($v_ary_field as $v_key=>$v_each){
			if(isset($p_value[$v_each]) && $p_value[$v_each]!=''){
				$v_value[]=$v_each."=\"".\U::safe_sql_string($p_value[$v_each])."\"";
			}
			if(isset($p_equal[$v_each]) && $p_equal[$v_each]!=''){
				$v_cond[]=$v_each."=\"".\U::safe_sql_string($p_equal[$v_each])."\"";
			}
		}
		
		$v_query="UPDATE " . $this->get_db_table_prefix().$this->applicant_table." SET ".implode(',',$v_value)." WHERE ".implode(' AND ',$v_cond);
		$v_result = parent::execute_query($v_query);
		$this->applicant_set_table();//reset
		return $v_result;
	}
	
	public function applicant_get($p_equal,$p_order=NULL,$p_limit=NULL,$p_like_and=NULL,$p_like_or=NULL,$p_in=NULL,$p_not_and=NULL){
		if($this->applicant_table==''){
			$this->applicant_set_table();
		}
		$v_ary_field=$this->applicant_field;
		
		// $v_cond=" WHERE _rec_status=\"SHOW\" ";
		$v_cond='';
		$v_cond_and=array();
		$v_cond_like=array();//for p_like_or

		foreach($v_ary_field as $v_key=>$v_each){
			//equal
			if(isset($p_equal[$v_each]) && $p_equal[$v_each]!=''){
				// $v_cond .= " AND ".$v_each."=\"".\U::safe_sql_string($p_equal[$v_each])."\" ";
				$v_cond_and[]= " ".$v_each."=\"".\U::safe_sql_string($p_equal[$v_each])."\" ";
			}
			//LIKE AND
			if(isset($p_like_and[$v_each]) && $p_like_and[$v_each]!=''){
				$v_cond_and[]= " ".$v_each." LIKE \"%".\U::safe_sql_string($p_like_and[$v_each])."%\" ";
			}
			//LIKE OR
			if(isset($p_like_or[$v_each]) && $p_like_or[$v_each]!=''){
				$v_cond_like[]=$v_each." LIKE \"%".\U::safe_sql_string($p_like_or[$v_each])."%\"";
			}
			//IN
			if(isset($p_in[$v_each]) && $p_in[$v_each]!=''){

				//security
				foreach($p_in[$v_each] as $v_each_in){
					$v_each_in="\"".\U::safe_sql_string($v_each_in)."\"";
				}
				$v_cond_and[]= " ".$v_each." IN (".implode(",",$p_in[$v_each]).")";

			}
			//NOT AND
			if(isset($p_not_and[$v_each]) && $p_not_and[$v_each]!=''){
				$v_cond_and[]=' NOT '.$v_each." = \"".\U::safe_sql_string($p_not_and[$v_each])."\"";
			}
		}
		
		if(count($v_cond_and)>0){
			$v_cond=" WHERE ".implode(' AND ',$v_cond_and)."";
		}

		if(count($v_cond_like)>0){
			$v_cond=$v_cond." AND (".implode(' or ',$v_cond_like).") ";
		}
		
		$v_order_by = '';
		if($p_order != null){
			foreach($p_order as $v_value){
				if($v_order_by == '') $v_order_by = ' ORDER BY '.$v_value['order_by'].' '.$v_value['sort_by'];
				else $v_order_by .= ', ' . $v_value['order_by'] . ' ' .$v_value['sort_by'];
			}
		}

		$v_limit = '';
		if($p_limit['start'] !== null && $p_limit['num_rec'] !== null){
			$v_limit = ' LIMIT ' . \U::safe_sql_string($p_limit['start']) . ', ' . \U::safe_sql_string($p_limit['num_rec']);
		}

		$v_query="SELECT * FROM " . $this->get_db_table_prefix().$this->applicant_table." ".$v_cond.$v_order_by.$v_limit;
		$this->applicant_sql_total="SELECT COUNT(_rec_status) as total_rec FROM " . $this->get_db_table_prefix().$this->applicant_table." ".$v_cond;
		
		$v_result = parent::execute_query($v_query);
		$this->applicant_set_table();//reset
		if($v_result){
			foreach($v_result as $v_each){
				$v_each['psn_dob']=\E::get( 'obj_curr_module')->__to_display_date($v_each['psn_dob'],'date');
				$v_each['psn_date_of_conversion']=\E::get( 'obj_curr_module')->__to_display_date($v_each['psn_dob'],'date');
				$v_each['_rec_created_on']=\E::get( 'obj_curr_module')->__to_display_date($v_each['_rec_created_on']);
				$v_each['_rec_modified_on']=\E::get( 'obj_curr_module')->__to_display_date($v_each['_rec_modified_on']);
				$v_each['_rec_deleted_on']=\E::get( 'obj_curr_module')->__to_display_date($v_each['_rec_deleted_on']);
			}
		}
		return $v_result;
	}
	
	
	public function applicant_to_versioning($p_tablename_from,$p_cond_from,$p_tablename_to,$p_cond_to, $v_reg_id,$v_no_ic){
		$v_cond=array();
		$v_cond_update=array();
		$v_tablename='';
	
		//check existing
		$this->applicant_set_table($p_tablename_to);
		$v_result=$this->applicant_get($p_cond_to);

		//build condition.
		foreach($p_cond_from as $v_key=>$v_each){
			$v_cond_from[]=''.$v_key."=\"".\U::safe_sql_string($v_each)."\""; //for insert
			$v_cond_update_from[]='t1.'.$v_key."=\"".\U::safe_sql_string($v_each)."\""; //for update.
		}
		foreach($p_cond_to as $v_key=>$v_each){
			$v_cond_update_to[]='t2.'.$v_key."=\"".\U::safe_sql_string($v_each)."\""; //for update.
		}
		
		//prepare fields for each situation
		$this->applicant_set_table('applicant');
		$v_ary_field=$this->applicant_field;
		foreach($v_ary_field as $v_key=>$v_each){
			if($v_each!='psn_login_id' 
			&& $v_each!='psn_login_password'
			&& $v_each!='_rec_created_by'
			&& $v_each!='_rec_created_on'
			&& $v_each!='_rec_deleted_by'
			&& $v_each!='_rec_deleted_on'
			){
				$v_field_ins[$v_each]=$v_each;
				$v_field_sel[$v_each]=$v_each;
				$v_field_update[$v_each]="t2.".$v_each."=t1.".$v_each;
			}
		}
		
		if($p_tablename_to == 'nikah_applicant'){
			unset($v_field_update['psn_access']);
			unset($v_field_update['psn_company']);
			unset($v_field_update['psn_approve_status']);
			unset($v_field_update['psn_newsletter']);
			unset($v_field_update['psn_acl_portal']);
			unset($v_field_update['psn_acl_firm']);
			unset($v_field_update['psn_acl_emunakahat']);
			unset($v_field_update['psn_acl_agency']);
			unset($v_field_update['psn_acl_cms']);
		}
			
		if($p_tablename_from == 'nikah_applicant'){
			unset($v_field_ins['psn_access']);
			unset($v_field_ins['psn_company']);
			unset($v_field_ins['psn_approve_status']);
			unset($v_field_ins['psn_newsletter']);
			unset($v_field_ins['psn_acl_portal']);
			unset($v_field_ins['psn_acl_firm']);
			unset($v_field_ins['psn_acl_emunakahat']);
			unset($v_field_ins['psn_acl_agency']);
			unset($v_field_ins['psn_acl_cms']);
			unset($v_field_ins['psn_id']);
			unset($v_field_ins['psn_ethnic_detail']);
			
			unset($v_field_sel['psn_access']);
			unset($v_field_sel['psn_company']);
			unset($v_field_sel['psn_approve_status']);
			unset($v_field_sel['psn_newsletter']);
			unset($v_field_sel['psn_acl_portal']);
			unset($v_field_sel['psn_acl_firm']);
			unset($v_field_sel['psn_acl_emunakahat']);
			unset($v_field_sel['psn_acl_agency']);
			unset($v_field_sel['psn_acl_cms']);
			unset($v_field_sel['psn_id']);
			unset($v_field_sel['psn_ethnic_detail']);
			
			unset($v_field_update['psn_access']);
			unset($v_field_update['psn_company']);
			unset($v_field_update['psn_approve_status']);
			unset($v_field_update['psn_newsletter']);
			unset($v_field_update['psn_acl_portal']);
			unset($v_field_update['psn_acl_firm']);
			unset($v_field_update['psn_acl_emunakahat']);
			unset($v_field_update['psn_acl_agency']);
			unset($v_field_update['psn_acl_cms']);
			unset($v_field_update['psn_id']);
			unset($v_field_update['psn_ethnic_detail']);
		}
		if($v_result){
			unset($v_field_update['psn_id']);
			$v_query="UPDATE 
							".$this->get_db_table_prefix().$p_tablename_from." t1, 
							".$this->get_db_table_prefix().$p_tablename_to." t2
							SET ".implode(",",$v_field_update)." 
							WHERE 
							".implode(' AND ',$v_cond_update_from)."
							AND ".implode(' AND ',$v_cond_update_to)."
							";
							
			$v_result = parent::execute_query($v_query);
			
			//Reconnect for nikah
			if($p_tablename_from == 'nikah_applicant'){
				$v_query_where = '';
				
				if($v_no_ic == '1'){
					$v_query_where .= " psn_other_identification = '".\U::safe_sql_string($p_cond_from['psn_other_identification'])."'";
				}else{
					$v_query_where .= " psn_identification = ".\U::safe_sql_string($p_cond_from['psn_identification']);
				}
					$v_select_query = "SELECT * FROM " . $this->get_db_table_prefix()."applicant
					WHERE $v_query_where
				";
				
				$v_select_result = parent::execute_query($v_select_query);
				
				if(isset($v_select_result[0]['psn_id'])){
					$v_update_query = "UPDATE " . $this->get_db_table_prefix()."nikah_applicant SET psn_id = ".\U::safe_sql_string($v_select_result[0]['psn_id'])."
						WHERE reg_id = ".\U::safe_sql_string($v_reg_id)."
						AND $v_query_where
						";
				}
				$v_execute = parent::execute_query($v_update_query);
			}
			
		}else{
		 	$v_query="INSERT INTO " . $this->get_db_table_prefix().$p_tablename_to." 
							(".implode(',',$v_field_ins).") 
							SELECT ".implode(',',$v_field_sel)." 
							FROM " . $this->get_db_table_prefix().$p_tablename_from."
							WHERE ".implode(' AND ',$v_cond_from)."
							";
							
			$v_result = parent::execute_query($v_query);
			$v_result=parent::get_last_insert_id();
			
			//Reconnect for nikah
			if($p_tablename_from == 'nikah_applicant'){
				$v_nikah_where = '';
				
				if($v_no_ic =='1'){
					$v_nikah_where .= " AND psn_other_identification = '".\U::safe_sql_string($p_cond_from['psn_other_identification'])."'";
				}else{
					$v_nikah_where .= " AND psn_identification = ".\U::safe_sql_string($p_cond_from['psn_identification']);
				}
				// Put the psn_id into the nikah_applicant table
				$v_update_query = "UPDATE " . $this->get_db_table_prefix()."nikah_applicant SET psn_id = ".\U::safe_sql_string($v_result)."
					WHERE reg_id = ".\U::safe_sql_string($v_reg_id)."
					$v_nikah_where
					";
				$v_execute = parent::execute_query($v_update_query);
			}
		}
		return $v_result;
	}

  	public function applicant_attach_add($p_info){
		$v_query = "INSERT INTO ".$this->get_db_table_prefix()."applicant_attachment(
									psn_id,
									att_field,
									_rec_modified_by,
									_rec_modified_on,
									_rec_created_by,
									_rec_created_on
								)VALUE(
									\"".\U::safe_sql_string($p_info['psn_id'])."\",
									\"".\U::safe_sql_string($p_info['att_field'])."\",
									\"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									\"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\",
									\"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									\"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\"
								)ON DUPLICATE KEY UPDATE 
									_rec_modified_by=\"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									_rec_modified_on=\"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\",
									_rec_created_by=\"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									_rec_created_on=\"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\"
		";
		// echo $v_query;
		parent::execute_query($v_query);
		$p_table_info['att_id'] = parent::get_last_insert_id();
		$p_table_info['tbl_name'] = $this->get_db_table_prefix() . "aplnt";
		$p_table_info['tbl_id'] = $p_info['psn_id'].'_'.parent::get_last_insert_id();
		$p_table_info['_rec_created_by'] = \U::safe_sql_string($p_info['current_usr_id']);
		return $p_table_info;
	}


	public function applicant_attach_edit($p_info){
		$v_query = "UPDATE ".$this->get_db_table_prefix()."applicant_attachment SET 
									att_name = \"".\U::safe_sql_string($p_info['name'])."\",
									att_type = \"".\U::safe_sql_string($p_info['type'])."\",
									att_size = \"".\U::safe_sql_string($p_info['size'])."\",
									att_location = \"".\U::safe_sql_string($p_info['location'])."\",
									att_id = \"".\U::safe_sql_string($p_info['id'])."\",
									_rec_modified_by = \"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									_rec_modified_on = \"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\"
								WHERE psn_id = \"".\U::safe_sql_string($p_info['psn_id'])."\"
								AND att_field = \"".\U::safe_sql_string($p_info['field'])."\"";
		// echo $v_query;
		return parent::execute_query($v_query);
	}
	
	//==eMunakahat Applicant End

	//==eMunakahat Cerai Start
	public function cerai_add($p_info){
		$v_query = "INSERT INTO ". $this->get_db_table_prefix() ."cerai_reg(
									reg_state,
									reg_type,
									reg_reason,
									_rec_created_by,
									_rec_created_on,
									_rec_modified_by,
									_rec_modified_on,
									_rec_status
								)VALUE(
									\"".\U::safe_sql_string($p_info['reg_state'])."\",
									\"".\U::safe_sql_string($p_info['reg_type'])."\",
									\"".\U::safe_sql_string($p_info['reg_reason'])."\",
									\"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									\"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\",
									\"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									\"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\",
									'SHOW'
								);";
			
		$v_result = parent::execute_query($v_query);
		$v_id = false;
		if($v_result){
			$v_id = parent::get_last_insert_id();
		}
		return $v_id;
	}

	public function cerai_get( $p_id, $p_field=NULL ){
		if(!is_null($p_field) && is_array($p_field)){
			foreach($p_field AS $v_index=>$v_value){
				$p_field[$v_index] = \U::safe_sql_string($v_value);
			}

			$v_field_get = implode($p_field, ",");
		}else{
			$v_field_get = "*";
		}

		$v_query = 	"SELECT 
										".$v_field_get."
                  FROM " . $this->get_db_table_prefix() . "cerai_reg 
                  WHERE _rec_status = \"SHOW\" 
                  AND reg_id=\"" . \U::safe_sql_string( $p_id ) . "\"
                ";
		$v_result = parent::execute_query($v_query);
		return $v_result;
	}

	public function cerai_attach_add($p_info){
		$v_query = "INSERT INTO ".$this->get_db_table_prefix()."cerai_attachment(
									reg_id,
									att_field,
									_rec_modified_by,
									_rec_modified_on,
									_rec_created_by,
									_rec_created_on
								)VALUE(
									\"".\U::safe_sql_string($p_info['reg_id'])."\",
									\"".\U::safe_sql_string($p_info['att_field'])."\",
									\"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									\"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\",
									\"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									\"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\"
								)
		";

		parent::execute_query($v_query);
		
		$p_table_info['att_id'] = parent::get_last_insert_id();
		$p_table_info['tbl_name'] = $this->get_db_table_prefix() . "cerai";
		$p_table_info['tbl_id'] = $p_info['reg_id'].'_'.parent::get_last_insert_id();
		$p_table_info['_rec_created_by'] = \U::safe_sql_string($p_info['current_usr_id']);
		return $p_table_info;
	}

	public function cerai_attach_edit($p_info){
		$v_query = "UPDATE ".$this->get_db_table_prefix()."cerai_attachment SET 
									att_name = \"".\U::safe_sql_string($p_info['name'])."\",
									att_type = \"".\U::safe_sql_string($p_info['type'])."\",
									att_size = \"".\U::safe_sql_string($p_info['size'])."\",
									att_location = \"".\U::safe_sql_string($p_info['location'])."\",
									att_id = \"".\U::safe_sql_string($p_info['id'])."\",
									_rec_modified_by = \"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									_rec_modified_on = \"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\"
								WHERE reg_id = \"".\U::safe_sql_string($p_info['reg_id'])."\"
								AND att_field = \"".\U::safe_sql_string($p_info['field'])."\"";

		return parent::execute_query($v_query);
	}

	public function cerai_add_child($p_info){
		$v_field_list = "";
		$v_value_list = "";
		foreach($p_info AS $v_field=>$v_value){
			if($v_field!="current_usr_id" && $v_field!="current_datetime" && $v_field!="_rec_status"){
				$v_field_list[] = \U::safe_sql_string( $v_field );
				$v_value_list[] = \U::safe_sql_string( $v_value );
				$v_update_list[] = $v_field."=\"".\U::safe_sql_string($v_value)."\"";
			}
		}
    
		$v_rec_status="SHOW";
		if(isset($p_info['_rec_status'])){
			$v_rec_status=$p_info['_rec_status'];
		}

		$v_value_str = is_array($v_value_list)?"'".implode("','", $v_value_list). "'":"";

		$v_query = "INSERT INTO ". $this->get_db_table_prefix() ."cerai_child_infor(
                  " . implode(",",$v_field_list) . ",
									_rec_created_by,
									_rec_created_on,
									_rec_modified_by,
									_rec_modified_on,
									_rec_status
								)VALUE(
                  " . $v_value_str . ",
									\"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									\"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\",
									\"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									\"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\",
									'" . \U::safe_sql_string($v_rec_status) . "'
								)ON DUPLICATE KEY UPDATE ".implode(',',$v_update_list).",
                  _rec_modified_by=\"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									_rec_modified_on=\"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\",
									_rec_status='" . \U::safe_sql_string($v_rec_status) . "'
                ;";

		$v_result = parent::execute_query($v_query);
		$v_id = false;
		if($v_result){
			$v_id = parent::get_last_insert_id();
		}
		return $v_id;
	}

	public function cerai_get_child( $p_id, $p_field=NULL ){
		if(!is_null($p_field) && is_array($p_field)){
			foreach($p_field AS $v_index=>$v_value){
				$p_field[$v_index] = \U::safe_sql_string($v_value);
			}

			$v_field_get = implode($p_field, ",");
		}else{
			$v_field_get = "*";
		}

		$v_query = 	"SELECT ".$v_field_get."
                  FROM " . $this->get_db_table_prefix() . "cerai_child_infor 
                  WHERE _rec_status != \"DELETED\" 
                  AND reg_id=\"" . \U::safe_sql_string( $p_id ) . "\"
                  ORDER BY reg_child_sequence ASC
                ";
		$v_result = parent::execute_query($v_query);
		return $v_result;
	}

	public function cerai_add_asset($p_info){
		$v_field_list = "";
		$v_value_list = "";
		foreach($p_info AS $v_field=>$v_value){
			if($v_field!="current_usr_id" && $v_field!="current_datetime" && $v_field!="_rec_status"){
				$v_field_list[] = \U::safe_sql_string( $v_field );
				$v_value_list[] = \U::safe_sql_string( $v_value );
				$v_update_list[] = $v_field."=\"".\U::safe_sql_string($v_value)."\"";
			}
		}
    
		$v_rec_status="SHOW";
		if(isset($p_info['_rec_status'])){
			$v_rec_status=$p_info['_rec_status'];
		}

		$v_value_str = is_array($v_value_list)?"'".implode("','", $v_value_list). "'":"";

		$v_query = "INSERT INTO ". $this->get_db_table_prefix() ."cerai_asset_infor(
                  " . implode(",",$v_field_list) . ",
									_rec_created_by,
									_rec_created_on,
									_rec_modified_by,
									_rec_modified_on,
									_rec_status
								)VALUE(
                  " . $v_value_str . ",
									\"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									\"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\",
									\"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									\"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\",
									'" . \U::safe_sql_string($v_rec_status) . "'
								)ON DUPLICATE KEY UPDATE ".implode(',',$v_update_list).",
                  _rec_modified_by=\"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									_rec_modified_on=\"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\",
									_rec_status='" . \U::safe_sql_string($v_rec_status) . "'
                ;";

		$v_result = parent::execute_query($v_query);
		$v_id = false;
		if($v_result){
			$v_id = parent::get_last_insert_id();
		}
		return $v_id;
	}

	public function cerai_get_asset( $p_id, $p_field=NULL ){
		if(!is_null($p_field) && is_array($p_field)){
			foreach($p_field AS $v_index=>$v_value){
				$p_field[$v_index] = \U::safe_sql_string($v_value);
			}

			$v_field_get = implode($p_field, ",");
		}else{
			$v_field_get = "*";
		}

		$v_query = 	"SELECT ".$v_field_get."
                  FROM " . $this->get_db_table_prefix() . "cerai_asset_infor 
                  WHERE _rec_status != \"DELETED\" 
                  AND reg_id=\"" . \U::safe_sql_string( $p_id ) . "\"
                  ORDER BY reg_asset_id ASC
                ";
		$v_result = parent::execute_query($v_query);
		return $v_result;
	}
	//==eMunakahat Cerai End******************************************************//

	//==eMunakahat Nikah Luar Negara Start******************************************************//
	public function nikah_ln_add($p_info){
		$v_field_list = "";
		$v_value_list = "";
		foreach($p_info AS $v_field=>$v_value){
			if($v_field!="current_usr_id" && $v_field!="current_datetime" && $v_field!="_rec_status"){
				$v_field_list[] = \U::safe_sql_string( $v_field );
				$v_value_list[] = \U::safe_sql_string( $v_value );
			}
		}
		$v_rec_status="SHOW";
		if(isset($p_info['_rec_status'])){
			$v_rec_status=$p_info['_rec_status'];
		}

		$v_value_str = is_array($v_value_list)?"'".implode("','", $v_value_list). "'":"";

		$v_query = "INSERT INTO ". $this->get_db_table_prefix() ."nikah_ln_reg(
                  " . implode(",",$v_field_list) . ",
									_rec_created_by,
									_rec_created_on,
									_rec_modified_by,
									_rec_modified_on,
									_rec_status
								)VALUE(
                  " . $v_value_str . ",
									\"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									\"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\",
									\"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									\"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\",
									\"" . \U::safe_sql_string($v_rec_status) . "\"
								);";
			
		$v_result = parent::execute_query($v_query);
		$v_id = false;
		if($v_result){
			$v_id = parent::get_last_insert_id();
		}
		return $v_id;
	}

	public function nikah_ln_edit($p_info, $p_id){
		$v_field_arr = null;
		if(!is_null($p_info) && is_array($p_info)){
			foreach($p_info AS $v_field=>$v_value){
				if($v_field!="current_usr_id" && $v_field!="current_datetime"){
					$v_field_arr[] = $v_field."='".\U::safe_sql_string( $v_value )."'";
				}
			}
		}
		if( !is_null( $v_field_arr ) ){
			$v_field_arr[] = "_rec_modified_by = '" . \U::safe_sql_string($p_info['current_usr_id']) . "'";
			$v_field_arr[] = "_rec_modified_on = '" . parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime'])) . "'";
			$v_field_upd = implode(",", $v_field_arr);
			$v_query = "UPDATE " . $this->get_db_table_prefix() . "nikah_ln_reg SET ".$v_field_upd." WHERE reg_id='" . \U::safe_sql_string( $p_id ) . "'";
			return parent::execute_query($v_query);
		}else{
			return false;
		}
	}

	public function nikah_ln_get( $p_id, $p_field=NULL ){
		if(!is_null($p_field) && is_array($p_field)){
			foreach($p_field AS $v_index=>$v_value){
				$p_field[$v_index] = \U::safe_sql_string($v_value);
			}

			$v_field_get = implode($p_field, ",");
		}else{
			$v_field_get = "*";
		}

		$v_query = 	"SELECT ".$v_field_get."
                  FROM " . $this->get_db_table_prefix() . "nikah_ln_reg 
                  WHERE 
                  (_rec_status = \"SHOW\" OR _rec_status = \"DRAFT\")
                  AND reg_id=\"" . \U::safe_sql_string( $p_id ) . "\"
                ";
		$v_result = parent::execute_query($v_query);
		return $v_result;
	}

	public function nikah_ln_attach_add($p_info){
		$v_query = "INSERT INTO ".$this->get_db_table_prefix()."nikah_ln_attachment(
									reg_id,
									att_field,
									_rec_modified_by,
									_rec_modified_on,
									_rec_created_by,
									_rec_created_on
								)VALUE(
									\"".\U::safe_sql_string($p_info['reg_id'])."\",
									\"".\U::safe_sql_string($p_info['att_field'])."\",
									\"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									\"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\",
									\"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									\"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\"
								)
		";

		parent::execute_query($v_query);
		$p_table_info['att_id'] = parent::get_last_insert_id();
		$p_table_info['tbl_name'] = $this->get_db_table_prefix() . "nkhln";
		$p_table_info['tbl_id'] = $p_info['reg_id'].'_'.parent::get_last_insert_id();
		$p_table_info['_rec_created_by'] = \U::safe_sql_string($p_info['current_usr_id']);
		return $p_table_info;
	}

	public function nikah_ln_attach_edit($p_info){
		$v_query = "UPDATE ".$this->get_db_table_prefix()."nikah_ln_attachment SET 
									att_name = \"".\U::safe_sql_string($p_info['name'])."\",
									att_type = \"".\U::safe_sql_string($p_info['type'])."\",
									att_size = \"".\U::safe_sql_string($p_info['size'])."\",
									att_location = \"".\U::safe_sql_string($p_info['location'])."\",
									att_id = \"".\U::safe_sql_string($p_info['id'])."\",
									_rec_modified_by = \"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									_rec_modified_on = \"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\"
								WHERE reg_id = \"".\U::safe_sql_string($p_info['reg_id'])."\"
								AND att_field = \"".\U::safe_sql_string($p_info['field'])."\"";

		return parent::execute_query($v_query);
	}

	public function nikah_ln_attach_get( $p_reg_id, $p_id=null, $p_field_filter=null, $p_field=null ){
		/* Field List */
		if(!is_null($p_field) && is_array($p_field)){
			foreach($p_field AS $v_index=>$v_value){
				$p_field[$v_index] = \U::safe_sql_string($v_value);
			}

			$v_field_get = implode($p_field, ",");
		}else{
			$v_field_get = "*";
		}

		/* CONDITION - Coding */
		$v_where = '';
		if(!is_null($p_id)){
			$v_where .= " AND id='".\U::safe_sql_string($p_id)."'";
		}
		if(!is_null($p_field_filter)){
			$v_where .= " AND att_field='".\U::safe_sql_string($p_field_filter)."'";
		}

		$v_query = 	"SELECT 
										".$v_field_get."
                  FROM " . $this->get_db_table_prefix() . "nikah_ln_attachment
                  WHERE _rec_status = \"SHOW\" 
                  AND reg_id='" . \U::safe_sql_string( $p_reg_id ) . "'
                ".$v_where;
		$v_result = parent::execute_query($v_query);
		return $v_result;
	}

	public function nikah_ln_add_child($p_info){
		$v_field_list = "";
		$v_value_list = "";
		foreach($p_info AS $v_field=>$v_value){
			if($v_field!="current_usr_id" && $v_field!="current_datetime" && $v_field!="_rec_status"){
				$v_field_list[] = \U::safe_sql_string( $v_field );
				$v_value_list[] = \U::safe_sql_string( $v_value );
				$v_update_list[] = $v_field."=\"".\U::safe_sql_string($v_value)."\"";
			}
		}
    
		$v_rec_status="SHOW";
		if(isset($p_info['_rec_status'])){
			$v_rec_status=$p_info['_rec_status'];
		}

		$v_value_str = is_array($v_value_list)?"'".implode("','", $v_value_list). "'":"";

		$v_query = "INSERT INTO ". $this->get_db_table_prefix() ."nikah_ln_child_infor(
                  " . implode(",",$v_field_list) . ",
									_rec_created_by,
									_rec_created_on,
									_rec_modified_by,
									_rec_modified_on,
									_rec_status
								)VALUE(
                  " . $v_value_str . ",
									\"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									\"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\",
									\"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									\"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\",
									'" . \U::safe_sql_string($v_rec_status) . "'
								)ON DUPLICATE KEY UPDATE ".implode(',',$v_update_list).",
                  _rec_modified_by=\"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									_rec_modified_on=\"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\",
									_rec_status='" . \U::safe_sql_string($v_rec_status) . "'
                ;";

		$v_result = parent::execute_query($v_query);
		$v_id = false;
		if($v_result){
			$v_id = parent::get_last_insert_id();
		}
		return $v_id;
	}

	public function nikah_ln_get_child( $p_id, $p_field=NULL ){
		if(!is_null($p_field) && is_array($p_field)){
			foreach($p_field AS $v_index=>$v_value){
				$p_field[$v_index] = \U::safe_sql_string($v_value);
			}

			$v_field_get = implode($p_field, ",");
		}else{
			$v_field_get = "*";
		}

		$v_query = 	"SELECT 
										".$v_field_get."
                  FROM " . $this->get_db_table_prefix() . "nikah_ln_child_infor 
                  WHERE _rec_status != \"DELETED\" 
                  AND reg_id=\"" . \U::safe_sql_string( $p_id ) . "\"
                  ORDER BY reg_child_id ASC
                ";
		$v_result = parent::execute_query($v_query);
		return $v_result;
	}
	
	//******************************************************eMunakahat Nikah Luar Negara End******************************************************//
	
	//******************************************************eMunakahat Ruju Start******************************************************//
	public $ruju_field=array();
	public $ruju_applicant_field=array();
	public $ruju_sql_total;

	//use this to change table
	public function ruju_get_field(){
	
		$v_field=array(
		'id',
		'regno',
		'nikah_reg_id',
		'nikah_date',
		'nikah_regno',
		'nikah_state',
		'nikah_division',
		'cerai_regno',
		'cerai_reg_id',
		'cerai_date',
		'cerai_count',
		'cerai_state',
		'cerai_division',
		'cerai_type',
		'cerai_wife_situation_before',
		'cerai_wife_situation_after',
		'cerai_wife_situation_after_haid_count',
		'verify',
		'verify_officer_id',
		'verify_officer_name',
		'verify_officer_position',
		'verify_date',
		'approval_officer_id', 
		'approval_officer_name', 
		'approval_notauliah', 
		'approval_lafazruju', 
		'approval_wife_agreement', 
		'approval', 
		'approval_date', 
		'approval_reason', 
		'witness1_name', 
		'witness1_myid', 
		'witness2_name', 
		'witness2_myid',
		'payment',
		'payment_officer_id',
		'payment_officer_name',
		'payment_type',
		'payment_total',
		'_rec_created_by',
		'_rec_created_on',	
		'_rec_modified_by',
		'_rec_modified_on',	
		'_rec_deleted_by',
		'_rec_deleted_on',
		'_rec_status'
		);
		$this->ruju_field=$v_field;
		return $v_field;
	}
	
	//process values for add, edit..
	public function ruju_process_field(&$p_value,$p_crud){
		//add
		if($p_crud=='add'){
		}
		//edit
		if($p_crud=='edit'){
		}
		
		//all
		if(isset($p_value['nikah_date']) && $p_value['nikah_date']!=''){
			$p_value['nikah_date']=\E::get( 'obj_curr_module')->__to_system_date($p_value['nikah_date'],'date');
		}else{
			unset($p_value['nikah_date']);
		}
		if(isset($p_value['cerai_date']) && $p_value['cerai_date']!=''){
			$p_value['cerai_date']=\E::get( 'obj_curr_module')->__to_system_date($p_value['cerai_date'],'date');
		}else{
			unset($p_value['cerai_date']);
		}
		if(isset($p_value['verify_date']) && $p_value['verify_date']!=''){
			$p_value['verify_date']=\E::get( 'obj_curr_module')->__to_system_date($p_value['verify_date'],'date');
		}else{
			unset($p_value['verify_date']);
		}
		if(isset($p_value['approval_date']) && $p_value['approval_date']!=''){
			$p_value['approval_date']=\E::get( 'obj_curr_module')->__to_system_date($p_value['approval_date'],'date');
		}else{
			unset($p_value['approval_date']);
		}
	}
	
	public function ruju_add($p_value){
		$v_ary_field=$this->ruju_get_field();	
		
		$this->ruju_process_field($p_value,'add');
		
		foreach($v_ary_field as $v_key=>$v_each){
			if(isset($p_value[$v_each]) && $p_value[$v_each]!=''){
				$v_field[]=$v_each;
				$v_value[]="\"".\U::safe_sql_string($p_value[$v_each])."\"";
				$v_update[]=$v_each."=\"".\U::safe_sql_string($p_value[$v_each])."\"";
			}
		}
		
		$v_query="INSERT INTO " . $this->get_db_table_prefix()."ruju_reg 
							(".implode(',',$v_field).") VALUES (".implode(',',$v_value).")
							ON DUPLICATE KEY UPDATE ".implode(',',$v_update)."
							";
		// echo $v_query;
		$v_result = parent::execute_query($v_query);
		$v_id=parent::get_last_insert_id();
		return $v_id;
	}
	
	public function ruju_edit($p_value,$p_equal){
		$v_ary_field=$this->ruju_get_field();
		
		$this->ruju_process_field($p_value,'edit');
		
		foreach($v_ary_field as $v_key=>$v_each){
			if(isset($p_value[$v_each]) && $p_value[$v_each]!=''){
				$v_value[]=$v_each."=\"".\U::safe_sql_string($p_value[$v_each])."\"";
			}
			if(isset($p_equal[$v_each]) && $p_equal[$v_each]!=''){
				$v_cond[]=$v_each."=\"".\U::safe_sql_string($p_equal[$v_each])."\"";
			}
		}
		
		$v_query="UPDATE " . $this->get_db_table_prefix()."ruju_reg SET ".implode(',',$v_value)." WHERE ".implode(' AND ',$v_cond);
		$v_result = parent::execute_query($v_query);
		// echo $v_query;
		return $v_result;
	}
	
	public function ruju_get($p_equal,$p_order=NULL,$p_limit=NULL,$p_like_and=NULL,$p_like_or=NULL,$p_in=NULL,$p_not_and=NULL){
		$v_ary_field=$this->ruju_get_field();
		
		// $v_cond=" WHERE _rec_status=\"SHOW\" ";
		$v_cond='';
		$v_cond_and=array();
		$v_cond_like=array();//for p_like_or

		foreach($v_ary_field as $v_key=>$v_each){
			//equal
			if(isset($p_equal[$v_each]) && $p_equal[$v_each]!=''){
				// $v_cond .= " AND ".$v_each."=\"".\U::safe_sql_string($p_equal[$v_each])."\" ";
				$v_cond_and[]= " ".$v_each."=\"".\U::safe_sql_string($p_equal[$v_each])."\" ";
			}
			//LIKE AND
			if(isset($p_like_and[$v_each]) && $p_like_and[$v_each]!=''){
				$v_cond_and[]= " ".$v_each." LIKE \"%".\U::safe_sql_string($p_like_and[$v_each])."%\" ";
			}
			//LIKE OR
			if(isset($p_like_or[$v_each]) && $p_like_or[$v_each]!=''){
				$v_cond_like[]=$v_each." LIKE \"%".\U::safe_sql_string($p_like_or[$v_each])."%\"";
			}
			//IN
			if(isset($p_in[$v_each]) && $p_in[$v_each]!=''){

				//security
				foreach($p_in[$v_each] as $v_each_in){
					$v_each_in="\"".\U::safe_sql_string($v_each_in)."\"";
				}
				$v_cond_and[]= " ".$v_each." IN (".implode(",",$p_in[$v_each]).")";

			}
			//NOT AND
			if(isset($p_not_and[$v_each]) && $p_not_and[$v_each]!=''){
				$v_cond_and[]=' NOT '.$v_each." = \"".\U::safe_sql_string($p_not_and[$v_each])."\"";
			}
		}
		
		if(count($v_cond_and)>0){
			$v_cond=" WHERE ".implode(' AND ',$v_cond_and)."";
		}

		if(count($v_cond_like)>0){
			$v_cond=$v_cond." AND (".implode(' or ',$v_cond_like).") ";
		}
		
		$v_order_by = '';
		if($p_order != null){
			foreach($p_order as $v_value){
				if($v_order_by == '') $v_order_by = ' ORDER BY '.$v_value['order_by'].' '.$v_value['sort_by'];
				else $v_order_by .= ', ' . $v_value['order_by'] . ' ' .$v_value['sort_by'];
			}
		}

		$v_limit = '';
		if($p_limit['start'] !== null && $p_limit['num_rec'] !== null){
			$v_limit = ' LIMIT ' . \U::safe_sql_string($p_limit['start']) . ', ' . \U::safe_sql_string($p_limit['num_rec']);
		}

		$v_query="SELECT * FROM " . $this->get_db_table_prefix()."ruju_reg ".$v_cond.$v_order_by.$v_limit;
		$this->ruju_sql_total="SELECT COUNT(_rec_status) as total_rec FROM " . $this->get_db_table_prefix()."ruju_reg ".$v_cond;
		// echo $v_query;
		$v_result = parent::execute_query($v_query);
		if($v_result){
			foreach($v_result as $v_each){
				$v_each['nikah_date']=\E::get('obj_curr_module')->__to_display_date($v_each['nikah_date'],'date');
				$v_each['cerai_date']=\E::get('obj_curr_module')->__to_display_date($v_each['cerai_date'],'date');
				$v_each['verify_date']=\E::get('obj_curr_module')->__to_display_date($v_each['verify_date'],'date');
				$v_each['approval_date']=\E::get('obj_curr_module')->__to_display_date($v_each['approval_date'],'date');
				$v_each['_rec_created_on']=\E::get('obj_curr_module')->__to_display_date($v_each['_rec_created_on']);
				$v_each['_rec_modified_on']=\E::get('obj_curr_module')->__to_display_date($v_each['_rec_modified_on']);
				$v_each['_rec_deleted_on']=\E::get('obj_curr_module')->__to_display_date($v_each['_rec_deleted_on']);
			}
		}
		return $v_result;
	}
	
	public function ruju_get_total(){
		$v_result = parent::execute_query($this->ruju_sql_total);
		return $v_result[0]['total_rec'];
	}

	/* ------------------------------ Attachment ------------------------------------------- */
	public function ruju_attach_add($p_info){
		$v_query = "INSERT INTO ".$this->get_db_table_prefix()."ruju_attachment(
									reg_id,
									att_field,
									_rec_modified_by,
									_rec_modified_on,
									_rec_created_by,
									_rec_created_on
								)VALUE(
									\"".\U::safe_sql_string($p_info['reg_id'])."\",
									\"".\U::safe_sql_string($p_info['att_field'])."\",
									\"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									\"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\",
									\"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									\"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\"
								)ON DUPLICATE KEY UPDATE 
									_rec_modified_by=\"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									_rec_modified_on=\"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\",
									_rec_created_by=\"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									_rec_created_on=\"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\"
		";
		// echo $v_query;
		parent::execute_query($v_query);
		$p_table_info['att_id'] = parent::get_last_insert_id();
		$p_table_info['tbl_name'] = $this->get_db_table_prefix() . "ruju";
		$p_table_info['tbl_id'] = $p_info['reg_id'].'_'.parent::get_last_insert_id();
		$p_table_info['_rec_created_by'] = \U::safe_sql_string($p_info['current_usr_id']);
		return $p_table_info;
	}


	public function ruju_attach_edit($p_info){
		$v_query = "UPDATE ".$this->get_db_table_prefix()."ruju_attachment SET 
									att_name = \"".\U::safe_sql_string($p_info['name'])."\",
									att_type = \"".\U::safe_sql_string($p_info['type'])."\",
									att_size = \"".\U::safe_sql_string($p_info['size'])."\",
									att_location = \"".\U::safe_sql_string($p_info['location'])."\",
									att_id = \"".\U::safe_sql_string($p_info['id'])."\",
									_rec_modified_by = \"".\U::safe_sql_string($p_info['current_usr_id'])."\",
									_rec_modified_on = \"".parent::to_db_datetime(\U::safe_sql_string($p_info['current_datetime']))."\"
								WHERE reg_id = \"".\U::safe_sql_string($p_info['reg_id'])."\"
								AND att_field = \"".\U::safe_sql_string($p_info['field'])."\"";
		return parent::execute_query($v_query);
	}
	
	public function ruju_attach_get($p_info){
		$v_query = "SELECT * FROM ".$this->get_db_table_prefix()."ruju_attachment
								WHERE reg_id=\"".\U::safe_sql_string($p_info['reg_id'])."\" 
								AND att_field = \"".\U::safe_sql_string($p_info['field'])."\"
								";
		return parent::execute_query($v_query);
	}
	
	public function ruju_attach_delete($p_info){
		$v_query = "DELETE FROM ".$this->get_db_table_prefix()."ruju_attachment
								WHERE reg_id=\"".\U::safe_sql_string($p_info['reg_id'])."\" 
								AND att_field = \"".\U::safe_sql_string($p_info['field'])."\"
								";
		return parent::execute_query($v_query);
	}
	//******************************************************eMunakahat Ruju End******************************************************//
		/**************Start Running Number Retrieving**************/
	public function get_next_number($p_type, $p_division=NULL){
		$v_where = "";
		if(!is_null($p_division)){
			$v_where .= " AND division='" . \U::safe_sql_string($p_division) . "'";
		}
		
		$v_query = "SELECT
                    number
                  FROM " . $this->get_db_table_prefix() . "running_number
                  WHERE type='" . \U::safe_sql_string($p_type) . "'
                ".$v_where;

		$v_result = parent::execute_query($v_query);
		if(!$v_result){
			$v_query = "INSERT IGNORE INTO " . $this->get_db_table_prefix() . "running_number
			(type,division,number) VALUES 
			(\"".\U::safe_sql_string($p_type)."\",
			\"".\U::safe_sql_string($p_division)."\",
			\"1\")
			";
			$v_result = parent::execute_query($v_query);
			if($v_result){
				return '1';
			}else{
				return false;
			}
		}else{
			return $v_result[0]['number'];
		}
	}

	public function update_number($p_type, $p_division=NULL){
		$v_where = "";
		if(!is_null($p_division)){
			$v_where .= " AND division='" . \U::safe_sql_string($p_division) . "'";
		}
		
		$v_query = "UPDATE " . $this->get_db_table_prefix() . "running_number
                    SET number = number + 1
                  WHERE type='" . \U::safe_sql_string($p_type) . "'
                ".$v_where;

		$v_result = parent::execute_query($v_query);
	}
	/**************End Running Number Retrieving**************/
	
	public function get_branch_using_division($v_division_code){
		$v_query ="SELECT * FROM ". $this->get_db_table_prefix() ."branch_profile WHERE branch_division= \"".\U::safe_sql_string($v_division_code)."\" LIMIT 1
			";
		return $v_result = parent::execute_query($v_query);
	}
	
	public function branch_attachment_file_list( $p_condition=null, $p_order=null, $p_start = null, $p_num_of_rec = null ){
		// CONDITION - Coding
		$v_where = "";
		if(array_key_exists ('att_parent_id', $p_condition) && $p_condition['att_parent_id'] != ''){
			$v_where .= ' AND att_parent_id="' . \U::safe_sql_string($p_condition['att_parent_id']) . '"';
		}			
		if(array_key_exists ('att_module', $p_condition) && $p_condition['att_module'] != ''){
			$v_where .= ' AND att_module="' . \U::safe_sql_string($p_condition['att_module']) . '"';
		}
		if(array_key_exists ('att_id', $p_condition) && $p_condition['att_id'] != ''){
			$v_where .= ' AND att_id="' . \U::safe_sql_string($p_condition['att_id']) . '"';
		}
		// ORDER BY - Coding
		$v_order_by = '';
		if($p_order != null){
			foreach($p_order as $v_value){
				if($v_order_by == '') $v_order_by = ' ORDER BY '.$v_value['order_by'].' '.$v_value['sort_by'];
				else $v_order_by .= ', ' . $v_value['order_by'] . ' ' .$v_value['sort_by'];
			}
		}
		
		// LIMIT - Coding
		$v_limit = '';
		if($p_start != null && $p_num_of_rec != null){
			$v_limit = ' LIMIT ' . \U::safe_sql_string($p_start) . ', ' . \U::safe_sql_string($p_num_of_rec);
			
		}
		
		// QUERY - Coding
		$v_query = 	"SELECT 
						att_id,
						att_parent_id,
						att_title,
						att_name,
						att_type,
						att_size,
						_rec_status,
						_rec_created_by,
						_rec_created_on,
						_rec_modified_by,
						_rec_modified_on,
						_rec_deleted_by,
						_rec_deleted_on
					FROM " . $this->get_db_table_prefix() . "branch_signature 
					WHERE _rec_status = \"SHOW\" " . $v_where . $v_order_by . $v_limit;	
		$v_result = parent::execute_query($v_query);
		if($v_result && is_array($v_result)){
			$v_count = 0;
			foreach($v_result as $v_row){
				$v_result[$v_count]['_rec_created_on'] = 	parent::to_system_datetime($v_row['_rec_created_on']);
				$v_result[$v_count]['_rec_modified_on'] = 	parent::to_system_datetime($v_row['_rec_modified_on']);
				$v_result[$v_count]['_rec_deleted_on'] = 	parent::to_system_datetime($v_row['_rec_deleted_on']);
				$v_count++;
			}
		}
		return $v_result;
	}
	
	public function branch_signature_file_get( $p_id ){
		$v_query = "SELECT 
						att_parent_id,
						att_title,
						att_name,
						att_type,
						att_size,
						att_content
					FROM " . $this->get_db_table_prefix() . "branch_signature as t1
					LEFT JOIN " . $this->get_db_table_prefix() . "branch_signature_content as t2
							ON t1.att_id =  t2.parent_id 
							AND t2._rec_status = \"SHOW\" 
					WHERE t1.att_parent_id = \"" . \U::safe_sql_string($p_id) . "\" 
					AND t1._rec_status = \"SHOW\" 
					";
		
		$v_result = parent::execute_query($v_query);
		if($v_result && is_array($v_result)){
			$v_count = 0;
			foreach($v_result as $v_row){
				$v_result[$v_count]['_rec_created_on'] = 	parent::to_system_datetime($v_row['_rec_created_on']);
				$v_result[$v_count]['_rec_modified_on'] = 	parent::to_system_datetime($v_row['_rec_modified_on']);
				$v_result[$v_count]['_rec_deleted_on'] = 	parent::to_system_datetime($v_row['_rec_deleted_on']);
				$v_count++;
			}
		}
		return $v_result[0];
	}
	
	public function get_payment_amount($v_payment_code){
		$v_query = "SELECT * FROM " . $this->get_db_table_prefix() . "payment_profile
			WHERE payment_code = '".\U::safe_sql_string($v_payment_code)."'
			AND _rec_status = 'SHOW'
			";
		return parent::execute_query($v_query);
	}
	
	public function get_branch_using_district($v_district_code){
		$v_query ="SELECT * FROM ". $this->get_db_table_prefix() ."branch_profile WHERE branch_district= \"".\U::safe_sql_string($v_district_code)."\" LIMIT 1
			";
		return $v_result = parent::execute_query($v_query);
	}
	
	public function get_branch_list_array(){
		$v_query = "SELECT a.*,
		(SELECT kwd_value FROM ".$this->get_db_table_prefix()."keyword g, ".$this->get_db_table_prefix()."keyword_lbl f WHERE a.branch_division=g.key_code AND docunid=kwd_code AND key_title='division' AND kwd_lang='".\E::get('obj_curr_module')->get_lang()."') AS branch_division_locale
		FROM " . $this->get_db_table_prefix() . "branch_profile a";
		
		$v_result = parent::execute_query($v_query);
		if(is_array($v_result)){
			$v_counter=0;
			foreach ($v_result as $v_value){
				$v_district = $this->district_list($v_value['branch_division']);
				if(is_array($v_district)){
					foreach($v_district as $v_district_value){
						if($v_district_value['key_code'] == $v_value['branch_district']){	
							$v_return_array[$v_counter]['key_code'] = $v_value['branch_code'];
							$v_return_array[$v_counter]['kwd_value'] = $v_district_value['kwd_value'];
							$v_counter++;
						}
					}
				}
			}
		}
		return $v_return_array;
	}
	
	public function get_branch_using_code($v_branch_code){
		$v_query ="SELECT * FROM ". $this->get_db_table_prefix() ."branch_profile WHERE branch_code= \"".\U::safe_sql_string($v_branch_code)."\" LIMIT 1
			";
		return $v_result = parent::execute_query($v_query);
	}
	
	public function get_attachment_info($p_info){
		$v_query = "SELECT * FROM ".$this->get_db_table_prefix()."attachment_info"."
		WHERE id = \"".\U::safe_sql_string($p_info['id'])."\"
		AND _rec_status='SHOW'
		";
		return $v_result = parent::execute_query($v_query);
	}
	
	public function reset_sessid($p_info){
		$v_query = "UPDATE ".$this->get_db_table_prefix()."registration_nikah"."
		SET PHPSESSID = \"".\U::safe_sql_string($p_info['PHPSESSID'])."\"
		WHERE reg_id = \"".\U::safe_sql_string($p_info['reg_id'])."\"
		AND _rec_status='SHOW'
		";

		return $v_result = parent::execute_query($v_query);
	}
	
	public function list_jurunikah($p_order, $p_start, $p_num_of_rec, $p_info){
		$v_where = '';
		$v_order_by = '';
		if($p_order != null){
			foreach($p_order as $v_value){
				if($v_order_by == '') $v_order_by = ' ORDER BY '.$v_value['order_by'].' '.$v_value['sort_by'];
				else $v_order_by .= ', ' . $v_value['order_by'] . ' ' .$v_value['sort_by'];
			}
		}
		
		$v_limit = '';
		if($p_start !== null && $p_num_of_rec !== null){
			$v_limit = ' LIMIT ' . \U::safe_sql_string($p_start) . ', ' . \U::safe_sql_string($p_num_of_rec);
		}
		
		if(isset($p_info['jurunikah_name']) && $p_info['jurunikah_name']!=''){
			$v_where .= " AND jurunikah_name LIKE '%".\U::safe_sql_string($p_info['jurunikah_name'])."%'";
		}
		
		if(isset($p_info['jurunikah_myid']) && $p_info['jurunikah_myid']!=''){
			$v_where .= " AND jurunikah_myid LIKE '%".\U::safe_sql_string($p_info['jurunikah_myid'])."%'";
		}
		
		if(isset($p_info['jurunikah_tauliah']) && $p_info['jurunikah_tauliah']!=''){
			$v_where .= " AND jurunikah_tauliah LIKE '%".\U::safe_sql_string($p_info['jurunikah_tauliah'])."%'";
		}
		
		if(isset($p_info['jurunikah_division']) && $p_info['jurunikah_division']!=''){
			$v_where .= " AND jurunikah_division = '".\U::safe_sql_string($p_info['jurunikah_division'])."'";
		}
		
		if(isset($p_info['jurunikah_istikhlah']) && $p_info['jurunikah_istikhlah']!=''){
			$v_where .= " AND jurunikah_istikhlah = '".\U::safe_sql_string($p_info['jurunikah_istikhlah'])."'";
		}
		
		if(isset($p_info['jurunikah_id']) && $p_info['jurunikah_id']!=''){
			$v_where .= " AND jurunikah_id = '".\U::safe_sql_string($p_info['jurunikah_id'])."'";
		}
		
		$v_query =" SELECT SQL_CALC_FOUND_ROWS a.*
			FROM  ". $this->get_db_table_prefix() .
				"jurunikah a
					WHERE a._rec_status=\"SHOW\"
					$v_where
					$v_order_by
					$v_limit
				";
		return $v_result = parent::execute_query($v_query);
	}
	
	public function course_search_id_duplicate($my_id){
        $v_query = "SELECT a.*,b.* FROM " . $this->get_db_table_prefix() . "course_applicant a,
            " . $this->get_db_table_prefix() . "reg_course b
            WHERE
            a._rec_status = 'SHOW'
            AND b._rec_status = 'SHOW'
            AND a.reg_id = b.course_reg_id
            AND a.psn_identification = \"".\U::safe_sql_string($my_id)."\"
            ORDER BY b._rec_created_on DESC, b._rec_modified_on DESC
            LIMIT 1
        ";
        return $v_result = parent::execute_query($v_query);
    } 
}
?>