<?php
namespace moonlight\mmapi;

class jpwsystem_mysql extends \moonlight\db_mysql{

	private $v_ag_from='imp'; //default
	
	public function set_ag_from($v_string){
		$this->v_ag_from=$v_string;
	}

 /***********************************************Staff***********************************************************/
	public function staff_list_search( $p_order=null, $p_start = null, $p_num_of_rec = null , $p_search_name=NULL , $p_search_agency=NULL,$p_value=NULL){
		// ORDER BY - Coding
		$v_order_by = '';
		if($p_order != null){
			foreach($p_order as $v_value){
				if($v_order_by == '') $v_order_by = " ORDER BY ".\U::safe_sql_string($v_value['order_by'])." ".\U::safe_sql_string($v_value['sort_by']);
				else $v_order_by .= ", " . \U::safe_sql_string($v_value['order_by']) . " " .\U::safe_sql_string($v_value['sort_by']);
			}
		}
		
		// LIMIT - Coding
		$v_limit = '';
		if($p_start !== null && $p_num_of_rec !== null){
			$v_limit = " LIMIT " . \U::safe_sql_string($p_start) . ", " . \U::safe_sql_string($p_num_of_rec);
			
		}

		// SEARCH - Coding
		$v_search = '';

		if($p_search_name != null){
				if($v_search == '') $v_search = " AND a.usr_full_name LIKE \"%".\U::safe_sql_string($p_search_name)."%\" ";
		}
		// print $p_search_agency;
		if($p_search_agency != null){
			if($p_search_agency != "all"){
				if($v_search == '') {$v_search = " AND b.sys_ag_id = \"".\U::safe_sql_string($p_search_agency)."\" ";}
				else{$v_search .= " AND b.sys_ag_id =\"".\U::safe_sql_string($p_search_agency)."\" ";}
			}
		}

		//added by Ng on 23 Aug 2011. Enable to fetch by array of id. array("ids"=>array(1,2,3,4))
		if(!empty($p_value['ids'])){
			if(is_array($p_value['ids'])){
				$v_ids=implode(",",$p_value['ids']);
				$v_search .= " AND a.usr_id IN (".\U::safe_sql_string($v_ids).")";
			}else{
				$v_search .= " AND a.usr_id=\"".\U::safe_sql_string($v_ids)."\"";
			}
		}
		//added by Wong on 27 Dec 2011. Enable using from 
		$p_usr_from = "";
		if(isset($p_value['usr_from']) && $p_value['usr_from']!= ""){
			$p_usr_from = " OR a.usr_from = \"" . $p_value['usr_from'] . "\"";
		}
		
		// QUERY - Coding
		//IF(STRCMP(IFNULL(b.ag_id,'no'),'no'),'No agency',c.ag_code) as ag_code)
		$v_query = 	"SELECT 
                    a.usr_id,
                    a.usr_full_name,
					a.usr_short_name,
					a.mobile_no,
					a.phone_office,
					b.pos_name,
					c.ag_fax,
					c.ag_add_address,
					a.usr_email,
					a.work_address,
					a._rec_modified_on,
					b.div_id,
					'' as div_value,
					GROUP_CONCAT(DISTINCT b.sys_ag_id) as ag_id,
					GROUP_CONCAT(DISTINCT c.ag_code) as ag_code,
					GROUP_CONCAT(DISTINCT d.kwd_value) as kwd_value,
					GROUP_CONCAT(DISTINCT b.sys_ad_id) as ad_id 
                  FROM " . $this->get_db_table_prefix() . "user a,". $this->get_db_table_prefix() . "user_position b
				  LEFT OUTER JOIN ". $this->get_db_table_prefix() . "agency c ON c.ag_id = b.sys_ag_id
				  LEFT OUTER JOIN ". $this->get_db_table_prefix() . "agency_lbl d ON d.kwd_code = c.ag_id 
				  WHERE  b.usr_id = a.usr_id 
				  AND a._rec_status = \"SHOW\"
				  AND (a.usr_from = \"imp\" OR a.usr_from = \"ldap\" OR a.usr_from = \"scs\" OR a.usr_from = \"system\" ".$p_usr_from.")
                  " .$v_search. " GROUP BY usr_id " . $v_order_by . $v_limit;
// print $v_query ;
		$vResult = parent::execute_query($v_query);
		
		if($vResult && is_array($vResult)){
			foreach($vResult as $v_key=>$v_value){
				if(isset($v_value['div_id']) && $v_value['div_id']!=""){
					$v_query_div = "SELECT kwd_value FROM ". $this->get_db_table_prefix() . "loc_division_lbl 
									WHERE kwd_code_div_id = ".$v_value['div_id']."
									AND kwd_lang = \"en\" 
								   ";
					$vResultDiv = parent::execute_query($v_query_div);
					if($vResultDiv && is_array($vResultDiv)){
						$vResult[$v_key]['div_value'] = $vResultDiv[0]['kwd_value'];
					}
				}
			}
		}
		
		return $vResult;
  }
	
	public function staff_list_total_search($p_order=null, $p_start = null, $p_num_of_rec = null , $p_search_name , $p_search_agency){
		
		// Default Language
		// $v_lang_info = \E::get('obj_curr_module')->get_lang();

		// ORDER BY - Coding
		$v_order_by = '';
		if($p_order != null){
			foreach($p_order as $v_value){
				if($v_order_by == '') $v_order_by = " ORDER BY ".\U::safe_sql_string($v_value['order_by'])." ".\U::safe_sql_string($v_value['sort_by']);
				else $v_order_by .= ", " . \U::safe_sql_string($v_value['order_by']) . " " .\U::safe_sql_string($v_value['sort_by']);
			}
		}
		
		// LIMIT - Coding
		$v_limit = '';
		if($p_start !== null && $p_num_of_rec !== null){
			$v_limit = " LIMIT " . \U::safe_sql_string($p_start) . ", " . \U::safe_sql_string($p_num_of_rec);
			
		}
		// SEARCH - Coding
		$v_search = '';

		if($p_search_name != null){
				if($v_search == '') $v_search = " AND a.usr_full_name LIKE \"%".\U::safe_sql_string($p_search_name)."%\" ";
		}
		if($p_search_agency != null){
			if($p_search_agency != "all"){
				if($v_search == '') {$v_search = " AND b.sys_ag_id = \"".\U::safe_sql_string($p_search_agency)."\" ";}
				else{$v_search .= " AND b.sys_ag_id =\"".\U::safe_sql_string($p_search_agency)."\" ";}
			}
		}
		

	// QUERY - Coding
		$v_query = 	"SELECT 
                    COUNT(DISTINCT a.usr_id) AS 'total_rec'
                  FROM " . $this->get_db_table_prefix() . "user a,". $this->get_db_table_prefix() . "user_position b 
                  WHERE a._rec_status = \"SHOW\"
				  AND b.usr_id = a.usr_id  		
				  AND (a.usr_from = \"".\U::safe_sql_string($this->v_ag_from)."\" OR a.usr_from = \"ldap\" OR a.usr_from = \"imp\" OR a.usr_from = \"scs\" OR a.usr_from = \"system\") 				  
                  " .$v_search ;//. $v_order_by . $v_limit;					
// print $v_query;
    $vResult = parent::execute_query($v_query);

	return $vResult[0]['total_rec'];
  }
  
  public function get_staff_info( $p_staff_id,$p_lang= null){
		
		//original
		$v_query = 	"SELECT 
                    usr_id,
                    usr_full_name,
					usr_short_name
                  FROM " . $this->get_db_table_prefix() . "user a
				  WHERE  usr_id = \"" . \U::safe_sql_string($p_staff_id['id']) . "\"
				  ";
		
		//modified by Wong on 1 Aug 2011 to get agency full name if pass in module language
		$agency_lbl="";
		$p_join_table="";
		$p_condition="";

		if($p_lang && $p_lang != ""){
			$agency_lbl = "agcy_lbl.kwd_value,agcy_lbl.kwd_short_name,";
			$p_join_table = "LEFT OUTER JOIN ". $this->get_db_table_prefix() ."agency_lbl agcy_lbl ON agcy_lbl.kwd_code = agcy.ag_id ";
			$p_condition = "AND usr_pos.usr_id = a.usr_id ";
			$p_condition .= "AND (agcy.ag_id = usr_pos.sys_ag_id OR agcy.ag_id IS NULL) ";  //update by Tan to make sure user information is retrieved even there is no agency assigned
			$p_condition .= "AND (agcy_lbl.kwd_lang = \"".\U::safe_sql_string($p_lang)."\" OR agcy_lbl.kwd_lang IS NULL) ";  //update by Tan to make sure user information is retrieved even there is no agency assigned
		}
				
				
								// p.unit_id,
								// p.station_id,
								// p.div_id
								// left join " . $this->get_db_table_prefix() . "user_position p ON a.usr_id=p.usr_id
								 // AND agcy.ag_id=p.ag_id
		//modified by Ng to select all info 
		/*modified by Ng to change select from 'ag_id field' to 'sys_ag_id' */
		$v_query = 	"SELECT a.usr_id, 
								a.usr_full_name, 
								a.usr_short_name, 
								a.usr_new_ic_no, 
								a.usr_email, 
								a.employee_id, 
								a.phone_office,
								a.mobile_no,
								$agency_lbl
								GROUP_CONCAT(DISTINCT agcy.ag_id) as ag_id,
								agcy.ag_code,
								a.work_address,
								usr_pos.div_id,
								usr_pos.unit_id,
								usr_pos.sys_ad_id,
								usr_pos.pos_name
								FROM " . $this->get_db_table_prefix() . "user a,
								".$this->get_db_table_prefix()."user_position usr_pos 
								LEFT OUTER JOIN " . $this->get_db_table_prefix() . "agency agcy on agcy.ag_id=usr_pos.sys_ag_id
								$p_join_table
								WHERE a.usr_id = \"" . \U::safe_sql_string($p_staff_id['id']) . "\"
								AND usr_pos.usr_id = a.usr_id 
								$p_condition
								GROUP BY agcy.ag_id
							";
		// print $v_query;
		$vResult = parent::execute_query($v_query);

		return $vResult;
  }
  
  public function set_staff_info($p_value = null){
	$v_query = "UPDATE ".$this->get_db_table_prefix()."user SET
				phone_office = \"" .\U::safe_sql_string($p_value['phone_office']). "\",
				mobile_no = \"" .\U::safe_sql_string($p_value['mobile_no']). "\",
				work_address = \"" .\U::safe_sql_string($p_value['work_address']). "\",
				_rec_modified_by = \"" .\U::safe_sql_string($p_value['id']). "\",
				_rec_modified_on = \"" .\U::safe_sql_string($p_value['current_datetime']). "\"
				WHERE usr_id = \"". \U::safe_sql_string($p_value['id']) ."\"
				";
				// print $v_query;
	$vResult = parent::execute_query($v_query);
	// if($vResult){
		$v_update_field="";
		if(isset($p_value['agency_id']) && $p_value['agency_id']!=''){
			$v_update_field .=" sys_ag_id = \"" .\U::safe_sql_string($p_value['agency_id']). "\", ";
		}
		$v_extra_field="";
		if(isset($p_value['division_id']) && $p_value['division_id']!= ""){
			$v_extra_field .= "div_id = \"" . \U::safe_sql_string($p_value['division_id']) . "\",";
		}
		if(isset($p_value['sys_ad_id']) && $p_value['sys_ad_id']!= ""){
			$v_extra_field .= "sys_ad_id = \"" . \U::safe_sql_string($p_value['sys_ad_id']) . "\",";
		}
		if(isset($p_value['pos_name']) && $p_value['pos_name']!= ""){
			$v_extra_field .= "pos_name = \"" . \U::safe_sql_string($p_value['pos_name']) . "\",";
		}
		$v_query = "UPDATE ".$this->get_db_table_prefix()."user_position SET
				".$v_update_field."
				".$v_extra_field."
				_rec_modified_by = \"" .\U::safe_sql_string($p_value['id']). "\",
				_rec_modified_on = \"" .\U::safe_sql_string($p_value['current_datetime']). "\"
				WHERE usr_id = \"". \U::safe_sql_string($p_value['id']) ."\"
				AND pos_default=\"1\"
				";
				// print $v_query;
		$vResult = parent::execute_query($v_query);
		$vResultRow = parent::get_num_rows_affected();
	// }
	// print $vResultRow;
		if($vResultRow>0){
			return $vResult;
		}else{
			$v_agid = "";
			$v_agid_data = "";
			if(isset($p_value['agency_id']) && $p_value['agency_id']!=''){
				$v_agid = "sys_ag_id,";
				$v_agid_data =" \"" .\U::safe_sql_string($p_value['agency_id']). "\", ";
			}
			$v_query = "INSERT INTO ".$this->get_db_table_prefix()."user_position (
				usr_id,
				".$v_agid."
				div_id, 
				sys_ad_id, 
				pos_name, 
				pos_default,
				_rec_status,
				_rec_created_by,
				_rec_created_on)
				VALUES (
				\"". \U::safe_sql_string($p_value['id']) ."\",
				".$v_agid_data."
				\"" .\U::safe_sql_string($p_value['division_id']). "\",
				\"" .\U::safe_sql_string($p_value['sys_ad_id']). "\",
				\"" .\U::safe_sql_string($p_value['pos_name']). "\",
				\"1\",
				\"SHOW\",
				\"". \U::safe_sql_string($p_value['id']) ."\",
				\"". \U::safe_sql_string($p_value['current_datetime']) ."\"
				)";
			$vResult = parent::execute_query($v_query);
			return $vResult;
		}
  }
  
  public function get_staff_name($p_value=null){
		$v_query = 	"SELECT 
                    usr_id,
					usr_email,
                    usr_full_name,
					usr_short_name
                  FROM " . $this->get_db_table_prefix() . "user a
				  WHERE  usr_id = \"" . \U::safe_sql_string($p_value['usr_id']) . "\"
				  ";
		$vResult = parent::execute_query($v_query);
		return $vResult;
  }
  
  public function get_staff_info_in_group($p_value=null){
		$v_query = 	"SELECT 
                    usr_id,
					usr_email,
                    usr_full_name,
					usr_short_name
                  FROM " . $this->get_db_table_prefix() . "user a
				  WHERE  usr_id IN (" . \U::safe_sql_string($p_value['usr_id']) . ")
				  ";
		$vResult = parent::execute_query($v_query);
		return $vResult;
  }

	public function get_birthday_staff($p_value){
		//Staff ID Filter - Coding
		$v_staff_id = "";
		if(!empty($p_value['friend_list'])){
			if(is_array($p_value['friend_list'])){
				$v_staff_id = " AND usr_id IN (" . \U::safe_sql_string(implode(",", $p_value['friend_list'])) . ") ";
			}else{
				$v_staff_id = " AND usr_id IN (" . $p_value['friend_list'] . ") ";
			}
		}

		$v_query = "SELECT 
									usr_id, 									
									usr_full_name
								FROM " . $this->get_db_table_prefix() . "user 
								WHERE SUBSTRING(usr_new_ic_no,3,2)=DATE_FORMAT(curdate(),'%m')
								AND SUBSTRING(usr_new_ic_no,5,2)=DATE_FORMAT(curdate(),'%d')
								{$v_staff_id}
								ORDER BY 2 ASC;";

		$v_result = parent::execute_query($v_query);
		return $v_result;
	}

	public function get_upcoming_birthday_staff($p_value){
		//Staff ID Filter - Coding
		$v_staff_id = "";
		if(!empty($p_value['friend_list'])){
			if(is_array($p_value['friend_list'])){
				$v_staff_id = " AND usr_id IN (" . \U::safe_sql_string(implode(",", $p_value['friend_list'])) . ") ";
			}else{
				$v_staff_id = " AND usr_id IN (" . $p_value['friend_list'] . ") ";
			}
		}

		$v_query = "SELECT 
									usr_id,
									usr_full_name,
									SUBSTRING(usr_new_ic_no,3,2) AS 'bMonth',
									SUBSTRING(usr_new_ic_no,5,2) AS 'bDay'
								FROM " . $this->get_db_table_prefix() . "user 
								WHERE SUBSTRING(usr_new_ic_no,3,4)>DATE_FORMAT(curdate(),'%m%d')
								{$v_staff_id}
								ORDER BY 3,4,2 ASC LIMIT 0, 5;";

		$v_result = parent::execute_query($v_query);
		return $v_result;
	}
	
	public function directory_staff_list( $p_order=null, $p_start = null, $p_num_of_rec = null , $p_search = null){

		$v_lang = 'en';
		if(isset($p_search['lang']) && $p_search['lang'] != ""){
			$v_lang = $p_search['lang'];
		}
		
		// ORDER BY - Coding
		$v_order_by = '';
		if($p_order != null){
			foreach($p_order as $v_value){
				if($v_order_by == '') $v_order_by = " ORDER BY ".\U::safe_sql_string($v_value['order_by'])." ".\U::safe_sql_string($v_value['sort_by']);
				else $v_order_by .= ", " . \U::safe_sql_string($v_value['order_by']) . " " .\U::safe_sql_string($v_value['sort_by']);
			}
		}
		
		// LIMIT - Coding
		$v_limit = '';
		if($p_start !== null && $p_num_of_rec !== null){
			$v_limit = " LIMIT " . \U::safe_sql_string($p_start) . ", " . \U::safe_sql_string($p_num_of_rec);

		}

		// SEARCH - Coding
		$v_search = '';

		// print $p_search_agency;
		if(isset($p_search['agency']) && $p_search['agency'] != ""){
			$v_search .= " AND b.sys_ag_id =\"".\U::safe_sql_string($p_search['agency'])."\" ";
		}
		if(isset($p_search['division']) && $p_search['division'] != ""){
			$v_search .= " AND b.sys_ad_id =\"".\U::safe_sql_string($p_search['division'])."\" ";
		}
		if(isset($p_search['unit']) && $p_search['unit'] != ""){
			$v_search .= " AND b.unit_id =\"".\U::safe_sql_string($p_search['unit'])."\" ";
		}
		if(isset($p_search['name']) && $p_search['name'] != ""){
			$v_search .= " AND a.usr_full_name LIKE \"%".\U::safe_sql_string($p_search['name'])."%\" ";
		}
		
		// QUERY - Coding
		$v_query = 	"SELECT 
                    a.usr_id,
                    a.usr_full_name,
					a.usr_short_name,
					a.mobile_no,
					a.phone_office,
					b.pos_name,
					c.ag_fax,
					c.ag_add_address,
					a.usr_email,
					a.work_address,
					a._rec_modified_on,
					b.sys_ad_id,
					b.unit_id,
					e.kwd_value as div_value,
					f.kwd_value as unit_value,
					GROUP_CONCAT(DISTINCT b.sys_ag_id) as ag_id,
					GROUP_CONCAT(DISTINCT c.ag_code) as ag_code,
					GROUP_CONCAT(DISTINCT d.kwd_value) as kwd_value 
                  FROM " . $this->get_db_table_prefix() . "user a,". $this->get_db_table_prefix() . "user_position b
				  LEFT OUTER JOIN ". $this->get_db_table_prefix() . "agency c ON c.ag_id = b.sys_ag_id
				  LEFT OUTER JOIN ". $this->get_db_table_prefix() . "agency_lbl d ON d.kwd_code = c.ag_id
					
					LEFT OUTER JOIN t_sys_agency_dept_lbl e ON b.sys_ad_id=e.kwd_code_ad_id AND e.kwd_lang=\"".\U::safe_sql_string($v_lang)."\"
					LEFT OUTER JOIN t_sys_agency_unit_lbl f ON b.unit_id=f.kwd_code_unit_id AND f.kwd_lang=\"".\U::safe_sql_string($v_lang)."\"
					
				  WHERE  b.usr_id = a.usr_id 
				  AND a._rec_status = \"SHOW\"
                  " .$v_search. " GROUP BY usr_id " . $v_order_by . $v_limit;
// print $v_query ;
		$vResult = parent::execute_query($v_query);
		
		/* if($vResult && is_array($vResult)){
			foreach($vResult as $v_key=>$v_value){
				if(isset($v_value['sys_ad_id']) && $v_value['sys_ad_id']!=""){
					$v_query_div = "SELECT kwd_value FROM ". $this->get_db_table_prefix() . "agency_dept_lbl 
									WHERE kwd_code_ad_id = ".$v_value['sys_ad_id']."
									AND kwd_lang = \"".$v_lang."\" 
								   ";
					$vResultDiv = parent::execute_query($v_query_div);
					if($vResultDiv && is_array($vResultDiv)){
						$vResult[$v_key]['div_value'] = $vResultDiv[0]['kwd_value'];
					}
				}
				if(isset($v_value['unit_id']) && $v_value['unit_id']!=""){
					$v_query_unit = "SELECT kwd_value FROM ". $this->get_db_table_prefix() . "agency_unit_lbl 
									WHERE kwd_code_unit_id = ".$v_value['unit_id']."
									AND kwd_lang = \"".$v_lang."\" 
								   ";
					$vResultUnit = parent::execute_query($v_query_unit);
					if($vResultUnit && is_array($vResultUnit)){
						$vResult[$v_key]['unit_value'] = $vResultUnit[0]['kwd_value'];
					}
				}
			}
		} */
		
		return $vResult;
  }
  
  public function directory_staff_list_total( $p_order=null, $p_start = null, $p_num_of_rec = null , $p_search = null){

		// SEARCH - Coding
		$v_search = '';

		// print $p_search_agency;
		if($p_search['agency'] != null){
			$v_search .= " AND b.sys_ag_id =\"".\U::safe_sql_string($p_search['agency'])."\" ";
		}
		if($p_search['division'] != null){
			$v_search .= " AND b.sys_ad_id =\"".\U::safe_sql_string($p_search['division'])."\" ";
		}
		if($p_search['unit'] != null){
			$v_search .= " AND b.unit_id =\"".\U::safe_sql_string($p_search['unit'])."\" ";
		}
		if($p_search['name'] != null){
			$v_search .= " AND a.usr_full_name LIKE \"%".\U::safe_sql_string($p_search['name'])."%\" ";
		}
	
		$v_query = 	"SELECT 
                    COUNT(DISTINCT a.usr_id) AS 'total_rec'
                  FROM " . $this->get_db_table_prefix() . "user a,". $this->get_db_table_prefix() . "user_position b 
                  WHERE a._rec_status = \"SHOW\"
				  AND b.usr_id = a.usr_id  						  
                  " .$v_search ;		
// print $v_query ;
		
		$vResult = parent::execute_query($v_query);

		return $vResult[0]['total_rec'];
  }
  
 /***********************************************End staff******************************************************/
  
 /***********************************************Agency******************************************************/
  	public function get_agency_all($p_value){
		// currently only have english version. if in future, got two or more than two language, then change the parameter for kwd_lang to $p_value['v_lang']
		$v_cond="";
		//if pass in array of id, will fetch records based on the id
		if(!empty($p_value['ids'])){
			//make sure is array
			if(is_array($p_value['ids'])){
				$v_temp_ary=$p_value['ids'];
			}else{
				$v_temp_ary=explode(",",$p_value['ids']);
			}
			//a little bit of security precaution
			foreach($v_temp_ary as $v_each_id){
				$v_temp_ary_final[]=\U::safe_sql_string($v_each_id);
			}
			$v_cond .=" AND a.ag_id IN (".implode(",",$v_temp_ary_final).")";
		}
		
		$v_order_by=" b.kwd_value ASC ";
		if(!empty($p_value['orderby'])){
			$v_order_by=$p_value['orderby'];
		}
		
		$vQuery = "SELECT 
					a.ag_id,
					a.ag_code,
					a.ag_state_cat_id,
					b.kwd_value,
					b.kwd_short_name
					FROM " . $this->get_db_table_prefix() . "agency a,". $this->get_db_table_prefix() . "agency_lbl b
					  WHERE b.kwd_code = a.ag_id
					  AND a.ag_from = \"".\U::safe_sql_string($this->v_ag_from)."\"
					  AND a._rec_status = \"SHOW\"
					  AND b.kwd_lang = \"bm\"
						".$v_cond."
					ORDER BY ".\U::safe_sql_string($v_order_by)."
					";
					//i have remove the following line of code from query bcos the one given by ICTU doesn't have short code.
					//AND b.kwd_short_name is not NULL && b.kwd_short_name!=''
					// print $vQuery;
		$vResult = parent::execute_query($vQuery);
		// if($vResult && is_array($vResult)){
			// foreach($vResult as $v_key=>$v_value){
				// $vResult[$v_key]['_rec_modified_on'] = parent::__to_display_date($vResult[$v_key]['_rec_modified_on']);
			// }
		// }
		return $vResult;
	} 
	
  
	public function agency_list_search( $p_order=null, $p_start = null, $p_num_of_rec = null , $p_search_agency){
		// ORDER BY - Coding
		$v_order_by = '';
		if($p_order != null){
			foreach($p_order as $v_value){
				if($v_order_by == '') $v_order_by = " ORDER BY ".\U::safe_sql_string($v_value['order_by'])." ".\U::safe_sql_string($v_value['sort_by']);
				else $v_order_by .= ", " . \U::safe_sql_string($v_value['order_by']) . " " .\U::safe_sql_string($v_value['sort_by']);
			}
		}
		
		// LIMIT - Coding
		$v_limit = '';
		if($p_start !== null && $p_num_of_rec !== null){
			$v_limit = " LIMIT " . \U::safe_sql_string($p_start) . ", " . \U::safe_sql_string($p_num_of_rec);
			
		}
		// SEARCH - Coding
		$v_search = '';

		if($p_search_agency != null){
			$v_search = " AND (b.kwd_value LIKE \"%".\U::safe_sql_string($p_search_agency)."%\" OR b.kwd_short_name LIKE \"%".\U::safe_sql_string($p_search_agency)."%\") ";
		}
		
		// QUERY - Coding

		$v_query = 	"SELECT 
                    a.ag_id,
					a.ag_code,
					a.ag_add_address,
					a.ag_phone,
					a.ag_fax,
					a.ag_email,
					a.ag_website,
					a._rec_modified_on,
                    b.kwd_value,
					b.kwd_short_name
                  FROM " . $this->get_db_table_prefix() . "agency a,". $this->get_db_table_prefix() . "agency_lbl b
				  WHERE b.kwd_code = a.ag_id
				  AND a._rec_status = \"SHOW\"
				  and b.kwd_lang = \"bm\"
				  AND a.ag_from = \"".\U::safe_sql_string($this->v_ag_from)."\"
                  " .$v_search. $v_order_by . $v_limit;
// print $v_query;
		$vResult = parent::execute_query($v_query);
	return $vResult;
  }
	
  public function agency_list_total_search($p_order=null, $p_start = null, $p_num_of_rec = null , $p_search_agency){

		// Default Language
		// $v_lang_info = \E::get('obj_curr_module')->get_lang();

		// ORDER BY - Coding
		$v_order_by = '';
		if($p_order != null){
			foreach($p_order as $v_value){
				if($v_order_by == '') $v_order_by = " ORDER BY ".\U::safe_sql_string($v_value['order_by'])." ".\U::safe_sql_string($v_value['sort_by']);
				else $v_order_by .= ", " . \U::safe_sql_string($v_value['order_by']) . " " .\U::safe_sql_string($v_value['sort_by']);
			}
		}
		
		// LIMIT - Coding
		$v_limit = '';
		if($p_start !== null && $p_num_of_rec !== null){
			$v_limit = " LIMIT " . \U::safe_sql_string($p_start) . ", " . \U::safe_sql_string($p_num_of_rec);
			
		}
		// SEARCH - Coding
		$v_search = '';
		if($p_search_agency != null){
			$v_search = " AND (b.kwd_value LIKE \"%".\U::safe_sql_string($p_search_agency)."%\" OR b.kwd_short_name LIKE \"%".\U::safe_sql_string($p_search_agency)."%\") ";
		}
		

	// QUERY - Coding
		$v_query = 	"SELECT 
                    COUNT(a.ag_id) AS 'total_rec'
                   FROM " . $this->get_db_table_prefix() . "agency a,". $this->get_db_table_prefix() . "agency_lbl b
				  WHERE b.kwd_code = a.ag_id
				  AND a.ag_from = \"".\U::safe_sql_string($this->v_ag_from)."\"
				  and b.kwd_lang = \"bm\"
                  AND a._rec_status = \"SHOW\" 				  
                  " .$v_search;//. $v_order_by . $v_limit;					

     $vResult = parent::execute_query($v_query);
	return $vResult[0]['total_rec'];
  }
  
  public function get_agency_name($p_value){
		// QUERY - Coding
		$v_query = 	"SELECT 
                    b.kwd_value
                   FROM " . $this->get_db_table_prefix() . "agency a,". $this->get_db_table_prefix() . "agency_lbl b
				  WHERE b.kwd_code = a.ag_id
				  AND a.ag_id = \"".\U::safe_sql_string($p_value['ag_id'])."\"
				  and b.kwd_lang = \"bm\"
                  AND a._rec_status = \"SHOW\" 				  
                  ";

		 $vResult = parent::execute_query($v_query);
		return $vResult[0]['kwd_value'];
  }
 /***********************************************End Agency******************************************************/ 
 
 /********************************************************Division***********************************************************/
	//can pass array of id, $p_value['ids'] to fetch based on the id
	public function get_division_all($p_value){
		$v_cond="";
		//if pass in array of id, will fetch records based on the id
		if(!empty($p_value['ids'])){
			//make sure is array
			if(is_array($p_value['ids'])){
				$v_temp_ary=$p_value['ids'];
			}else{
				$v_temp_ary=explode(",",$p_value['ids']);
			}
			//a little bit of security precaution
			foreach($v_temp_ary as $v_each_id){
				$v_temp_ary_final[]=\U::safe_sql_string($v_each_id); //wrap each id with safeSqlString
			}
			$v_cond .=" AND dl.kwd_code_div_id IN (".implode(",",$v_temp_ary_final).") ";
		}
		
		$v_query="SELECT dl.kwd_code_div_id as div_id,
					kwd_value from " . $this->get_db_table_prefix() . "loc_division_lbl dl 
					LEFT JOIN " . $this->get_db_table_prefix() . "loc_division d ON d.div_id=dl.kwd_code_div_id
					WHERE d._rec_status=\"SHOW\" AND kwd_lang=\"en\"
					".$v_cond."
				";
		$v_result = parent::execute_query($v_query);
		return $v_result;
	}
/******************************************************End Division***********************************************************/
 
 /*********************************************** Holiday ******************************************************/
	public function holiday_list($p_order=null, $p_start = null, $p_num_of_rec = null , $p_value=null){
		// ORDER BY - Coding
		$v_order_by = '';
		if($p_order != null){
			foreach($p_order as $v_value){
				if($v_order_by == '') $v_order_by = " ORDER BY ".\U::safe_sql_string($v_value['order_by'])." ".\U::safe_sql_string($v_value['sort_by']);
				else $v_order_by .= ", " . \U::safe_sql_string($v_value['order_by']) . " " .\U::safe_sql_string($v_value['sort_by']);
			}
		}
		
		// LIMIT - Coding
		$v_limit = '';
		if($p_start !== null && $p_num_of_rec !== null){
			$v_limit = " LIMIT " . \U::safe_sql_string($p_start) . ", " . \U::safe_sql_string($p_num_of_rec);
			
		}
		
		$v_cond='';
		if(!empty($p_value['key'])){
			$v_cond=" AND hol_key=\"".\U::safe_sql_string($p_value['key'])."\" ";
		}
					
		$v_query = "SELECT hol_id,hol_date,hol_description,kwd_lang,kwd_value FROM " . $this->get_db_table_prefix() . "holiday ho
								LEFT JOIN " . $this->get_db_table_prefix() . "holiday_lbl lb
									ON lb.kwd_code = ho.hol_id AND lb._rec_status=\"SHOW\" 
									AND lb.kwd_lang=\"".\U::safe_sql_string(\E::get('obj_kernel_config')->get('general/lang'))."\"
								WHERE ho._rec_status= \"SHOW\"".$v_cond.$v_order_by.$v_limit;
     $v_result = parent::execute_query($v_query);
		return $v_result;
	}
 /***********************************************End Holiday******************************************************/ 
  
 /*********************************************** migrate user(temporary) ******************************************************/
	public function user_migrate($p_value=null){
						
		$v_query = "INSERT INTO " . $this->get_db_table_prefix() . "user 
					(
						usr_short_name,
						usr_from,
						usr_full_name,
						usr_new_ic_no,
						employee_id,
						phone_office,
						usr_password,
						_rec_status,
						_rec_created_by,
						_rec_created_on,
						_rec_modified_by,
						_rec_modified_on
					) VALUES (
						\"".$p_value['usr_short_name']."\",
						\"".$p_value['usr_from']."\",
						\"".$p_value['usr_full_name']."\",
						\"".$p_value['usr_new_ic_no']."\",
						\"".$p_value['employee_id']."\",
						\"".$p_value['phone_office']."\",
						\"".$p_value['usr_password']."\",
						\"".$p_value['_rec_status']."\",
						\"".$p_value['_rec_created_by']."\",
						\"".$p_value['_rec_created_on']."\",
						\"".$p_value['_rec_modified_by']."\",
						\"".$p_value['_rec_modified_on']."\"
					)";
					// print $v_query;
     $v_result = parent::execute_query($v_query);
		return parent::get_last_insert_id();
	}
	public function user_migrate_position($p_value=null){
						
		$v_query = "INSERT INTO " . $this->get_db_table_prefix() . "user_position 
					(
						usr_id,
						pos_sta_date,
						pos_grade,
						pos_name,
						pos_default,
						pos_status,
						sys_ag_id,
						sys_ad_id,
						_rec_status,
						_rec_created_by,
						_rec_created_on,
						_rec_modified_by,
						_rec_modified_on
					) VALUES (
						\"".$p_value['usr_id']."\",
						\"".$p_value['pos_sta_date']."\",
						\"".$p_value['pos_grade']."\",
						\"".$p_value['pos_name']."\",
						\"".$p_value['pos_default']."\",
						\"".$p_value['pos_status']."\",
						\"".$p_value['sys_ag_id']."\",
						\"".$p_value['sys_ad_id']."\",
						\"".$p_value['_rec_status']."\",
						\"".$p_value['_rec_created_by']."\",
						\"".$p_value['_rec_created_on']."\",
						\"".$p_value['_rec_modified_by']."\",
						\"".$p_value['_rec_modified_on']."\"
					)";
					// print $v_query;
     $v_result = parent::execute_query($v_query);
		// return parent::get_last_insert_id();
	}
 /***********************************************End migrate user(temporary)******************************************************/ 
 
 /***********************************************Start position******************************************************/ 
 public function get_position_list( $p_condition=null, $p_order=null, $p_start = null, $p_num_of_rec = null ){
		// CONDITION - Coding
		$v_where = '';
		// if(isset($p_condition['usr_id']) && $p_condition['usr_id'] != ""){
			// $v_where .= " AND usr_id = \"".\U::safe_sql_string($p_condition['usr_id'])."\" ";
		// }
		if(isset($p_condition['pos_name']) && $p_condition['pos_name'] != ""){
			$v_where .= " AND pos_name LIKE '%".\U::safe_sql_string($p_condition['pos_name'])."%' ";
		}
		// if(isset($p_condition['pos_status']) && $p_condition['pos_status'] != ""){
			// $v_where .= " AND pos_status = \"".\U::safe_sql_string($p_condition['pos_status'])."\" ";
		// }
		// if(isset($p_condition['pos_default']) && $p_condition['pos_default'] != ""){
			// $v_where .= " AND pos_default = \"".\U::safe_sql_string($p_condition['pos_default'])."\" ";
		// }
		// if(isset($p_condition['sys_ag_id']) && $p_condition['sys_ag_id'] != ""){
			// $v_where .= " AND sys_ag_id = \"".\U::safe_sql_string($p_condition['sys_ag_id'])."\" ";
		// }
		// if(isset($p_condition['sys_ad_id']) && $p_condition['sys_ad_id'] != ""){
			// $v_where .= " AND sys_ad_id = \"".\U::safe_sql_string($p_condition['sys_ad_id'])."\" ";
		// }
		
		// ORDER BY - Coding
		$v_order_by = '';
		if($p_order != null){
			foreach($p_order as $v_value){
				if($v_order_by == '') $v_order_by = ' ORDER BY '.$v_value['order_by'].' '.$v_value['sort_by'];
				else $v_order_by .= ', ' . $v_value['order_by'] . ' ' .$v_value['sort_by'];
			}
		}
		
		// LIMIT - Coding
		$v_limit = '';
		if($p_start !== null && $p_num_of_rec !== null){
			$v_limit = ' LIMIT ' . \U::safe_sql_string($p_start) . ', ' . \U::safe_sql_string($p_num_of_rec);
			
		}
		
		// QUERY - Coding
		$v_query = "SELECT distinct(pos_name)  
						FROM " . $this->get_db_table_prefix() . "user_position
						WHERE 1=1 AND _rec_status = \"SHOW\" " . $v_where . $v_order_by . $v_limit;
		// print $v_query;
		$v_result = parent::execute_query($v_query);
		
		// if($v_result && is_array($v_result)){
			// $v_count = 0;
			// foreach($v_result as $v_row){
			// $v_result[$v_count]['_rec_created_on'] = parent::to_system_datetime($v_row['_rec_created_on']);
			// $v_result[$v_count]['_rec_modified_on'] = parent::to_system_datetime($v_row['_rec_modified_on']);
			// $v_result[$v_count]['_rec_deleted_on'] = parent::to_system_datetime($v_row['_rec_deleted_on']);
			// $v_result[$v_count]['_rec_sync_on'] = parent::to_system_datetime($v_row['_rec_sync_on']);
			// $v_result[$v_count]['pos_sta_date'] = parent::to_system_datetime($v_row['pos_sta_date'],'DATE');
			// $v_result[$v_count]['pos_end_date'] = parent::to_system_datetime($v_row['pos_end_date'],'DATE');
			// $v_count++;
			// }
		// }
		
		return $v_result;
	}
/***********************************************End position******************************************************/ 
	 
/***********************************************Start department******************************************************/ 
 public function get_department_all( $p_condition=null, $p_order = null, $p_start = null, $p_num_of_rec = null){
		// CONDITION - Coding
		$v_where = '';
		
		if(!isset($p_condition['lang']) || $p_condition['lang'] == ""){
			$p_condition['lang'] = 'en';
		}
		$v_where .= " AND kwd_lang = \"".\U::safe_sql_string($p_condition['lang'])."\" ";
    
		// ORDER BY - Coding
		$v_order_by = '';
		if($p_order != null){
			foreach($p_order as $v_value){
				if($v_order_by == '') $v_order_by = ' ORDER BY '.$v_value['order_by'].' '.$v_value['sort_by'];
				else $v_order_by .= ', ' . $v_value['order_by'] . ' ' .$v_value['sort_by'];
			}
		}
		
		// LIMIT - Coding
		$v_limit = '';
		if($p_start !== null && $p_num_of_rec !== null){
			$v_limit = ' LIMIT ' . \U::safe_sql_string($p_start) . ', ' . \U::safe_sql_string($p_num_of_rec);
			
		}
			
		// QUERY - Coding
		$v_query = "SELECT SQL_CALC_FOUND_ROWS ad_id, kwd_value,ad_id, a._rec_modified_on 
						FROM " . $this->get_db_table_prefix() . "agency_dept a
						LEFT JOIN " . $this->get_db_table_prefix() . "agency_dept_lbl l on l.kwd_code_ad_id = a.ad_id
						WHERE 1=1 AND a._rec_status = \"SHOW\" " . $v_where . $v_order_by . $v_limit;
		// print $v_query;
		$v_result = parent::execute_query($v_query);
		
		return $v_result;
	}

	public function get_department_all_total(){
		$v_result = parent::execute_query(" SELECT FOUND_ROWS() as total_rec ");
		return $v_result[0]['total_rec'];
	}
	
	public function get_department_name( $p_condition=null){
		// CONDITION - Coding
		$v_where = '';
		
		if(!isset($p_condition['lang']) || $p_condition['lang'] == ""){
			$p_condition['lang'] = 'en';
		}
		$v_where .= " AND kwd_lang = \"".\U::safe_sql_string($p_condition['lang'])."\" ";
		
		if(isset($p_condition['ad_id']) && $p_condition['ad_id'] != ""){
			$v_where .= " AND ad_id = \"".\U::safe_sql_string($p_condition['ad_id'])."\" ";
		}
		
		// QUERY - Coding
		$v_query = "SELECT kwd_value,ad_id  
						FROM " . $this->get_db_table_prefix() . "agency_dept a
						LEFT JOIN " . $this->get_db_table_prefix() . "agency_dept_lbl l on l.kwd_code_ad_id = a.ad_id
						WHERE 1=1 AND a._rec_status = \"SHOW\" " . $v_where;
		// print $v_query;
		$v_result = parent::execute_query($v_query);
		
		return $v_result;
	}
/***********************************************End department******************************************************/ 

/***********************************************Start unit******************************************************/ 
 public function get_unit_all( $p_condition=null){
		// CONDITION - Coding
		$v_where = '';
		
		if(!isset($p_condition['lang']) || $p_condition['lang'] == ""){
			$p_condition['lang'] = 'en';
		}
		$v_where .= " AND kwd_lang = \"".\U::safe_sql_string($p_condition['lang'])."\" ";
			
		// QUERY - Coding
		$v_query = "SELECT kwd_value,unit_id  
						FROM " . $this->get_db_table_prefix() . "agency_unit a
						LEFT JOIN " . $this->get_db_table_prefix() . "agency_unit_lbl l on l.kwd_code_unit_id = a.unit_id
						WHERE 1=1 AND a._rec_status = \"SHOW\" " . $v_where;
		// print $v_query;
		$v_result = parent::execute_query($v_query);
		
		return $v_result;
	}
	
	 public function get_unit_name( $p_condition=null){
		// CONDITION - Coding
		$v_where = '';
		
		if(!isset($p_condition['lang']) || $p_condition['lang'] == ""){
			$p_condition['lang'] = 'en';
		}
		$v_where .= " AND kwd_lang = \"".\U::safe_sql_string($p_condition['lang'])."\" ";
		
		if(isset($p_condition['unit_id']) && $p_condition['unit_id'] != ""){
			$v_where .= " AND unit_id = \"".\U::safe_sql_string($p_condition['unit_id'])."\" ";
		}
		// QUERY - Coding
		$v_query = "SELECT kwd_value,unit_id  
						FROM " . $this->get_db_table_prefix() . "agency_unit a
						LEFT JOIN " . $this->get_db_table_prefix() . "agency_unit_lbl l on l.kwd_code_unit_id = a.unit_id
						WHERE 1=1 AND a._rec_status = \"SHOW\" " . $v_where;
		// print $v_query;
		$v_result = parent::execute_query($v_query);
		
		return $v_result;
	}
/***********************************************End unit******************************************************/

/***********************************************Start user******************************************************/ 
	public function get_user( $p_condition=null){
		// CONDITION - Coding
		$v_where = '';

		if(!is_null($p_condition) && is_array($p_condition)){
			if(isset($p_condition['usr_ic']) && $p_condition['usr_ic'] != ""){
				$v_where .= " AND usr_new_ic_no = \"".\U::safe_sql_string($p_condition['usr_ic'])."\" ";
			}

			if(isset($p_condition['pms_ic_no']) && $p_condition['pms_ic_no'] != ""){
				$v_where .= " AND pms_ic_no = \"".\U::safe_sql_string($p_condition['pms_ic_no'])."\" ";
			}

			// QUERY - Coding
			$v_query = "SELECT usr_id  
							FROM " . $this->get_db_table_prefix() . "user 
							WHERE _rec_status = \"SHOW\" " . $v_where;
			// print $v_query;
			$v_result = parent::execute_query($v_query);
			return $v_result[0]['usr_id'];
		}else{
			return 0;
		}
		
	}
/***********************************************End user******************************************************/

/***********************************************Start Last Updated Date******************************************************/ 
	public function get_last_updated_date( $p_condition=null){

		// QUERY - Coding
		$v_query = "SELECT _rec_modified_on  
						FROM " . $this->get_db_table_prefix() . "log 
						ORDER BY _rec_modified_on DESC
						LIMIT 0,1
					";
		// print $v_query;
		$v_result = parent::execute_query($v_query);
		if($v_result && is_array($v_result)){
			$v_result[0]['_rec_modified_on'] = parent::__to_display_date($v_result[0]['_rec_modified_on'], 'DATE');
		}
		return $v_result[0]['_rec_modified_on'];

	}
/***********************************************End Last Updated Date******************************************************/
}
?>