<?php
$v_map_lat = isset($v_map_lat) ? $v_map_lat : '0';
$v_map_lng = isset($v_map_lng) ? $v_map_lng : '0';
$v_map_width = isset($v_map_width) ? $v_map_width : '800px';
$v_map_height = isset($v_map_height) ? $v_map_height : '600px';
$v_map_lang = isset($v_map_lang) ? $v_map_lang : 'en';
$v_use_marker = strtolower(isset($v_use_marker) ? $v_use_marker : '');
if ($v_use_marker != 'true'){
	$v_use_marker = 'false';
}
$v_able_to_set_marker = strtolower(isset($v_able_to_set_marker) ? $v_able_to_set_marker : '');
if ($v_able_to_set_marker != 'true'){
	$v_able_to_set_marker = 'false';
}
$v_marker_name = isset($v_marker_name) ? $v_marker_name : 'Marker';
$v_div_map_name = isset($v_div_map_name) ? $v_div_map_name : 'map-canvas';
$v_search_callback = isset($v_search_callback) ? $v_search_callback : '';

$v_path = MOONLIGHT_PLUGIN_FULL_PATH . 'google_map/';
?>
<script type="text/javascript" src="http://maps.googleapis.com/maps/api/js?sensor=false&language='<?php echo $v_map_lang ?>'"></script>
<script type="text/javascript" src="http://www.google.com/uds/api?file=uds.js&v=1.0"></script>

<script language="javascript">
var divMapName = "<?php echo $v_div_map_name; ?>";
var divMapWidth = "<?php echo $v_map_width; ?>";
var divMapHeight = "<?php echo $v_map_height; ?>";
var map;
var use_marker = <?php echo $v_use_marker; ?>;
var able_to_set_marker = <?php echo $v_able_to_set_marker; ?>;
var marker;
var marker_name = "<?php echo $v_marker_name; ?>";
var geocoder = new google.maps.Geocoder();
var gLocalSearch;
var infowindow = new google.maps.InfoWindow({maxWidth: 1});
var showInfoWindow = false;
var searchCallback = "<?php echo $v_search_callback; ?>";

// Kuching Latitude and Longitude
var vHomeLat = <?php echo $v_map_lat; ?>;
var vHomeLng = <?php echo $v_map_lng; ?>;

var vLat;
var vLng;

function map_initialize( divMapName ){
	var latlng = new google.maps.LatLng(vHomeLat, vHomeLng);
	
	// for map option: zoom, center, and mapTypeId must be defined
	var myOptions = {
		zoom: 17,
		center: latlng,
		mapTypeControl: true,
		mapTypeId: google.maps.MapTypeId.ROADMAP,
		keyboardShortcuts: false,
		scaleControl: false,
		streetViewControl: false,
		navigationControl: true,
		navigationControlOptions: {style: google.maps.NavigationControlStyle.DEFAULT}
	};
	
	map = new google.maps.Map(document.getElementById(divMapName), myOptions);
	
	if (use_marker){
		marker = new google.maps.Marker({
			position: latlng, 
			map: map,
			title: marker_name
		});
	}
	vLat = latlng.lat();
	vLng = latlng.lng();
	if (showInfoWindow){
		updateInfoContent();
		if (use_marker){
			infowindow.open(ap, marker);
		}
	}
	
	// Initialize the local searcher
	gLocalSearch = new GlocalSearch();
	
	geocoder = new google.maps.Geocoder();
	
	
	if (use_marker && able_to_set_marker){
		google.maps.event.addListener(map, 'click', function(event){
			latlng = event.latLng;
			marker_lat = latlng.lat();
			marker_lng = latlng.lng();
			setMarker(marker_lat, marker_lng);
		} );
		
		google.maps.event.addListener(marker, 'click', function(event){
			if (showInfoWindow){
				infowindow.open(map, marker);
			}
		} );
	}
	
	var ControlDiv = document.createElement("DIV");
	var FullScreenButton = new createControlButton(ControlDiv);
	
	ControlDiv.style.marginTop = "3";
	ControlDiv.index = 3;
	map.controls[google.maps.ControlPosition.TOP].push(ControlDiv);
}


function createControlButton(div){
	var controlDiv = div;
	var whitespace = document.createElement("SPAN");
	whitespace.innerHTML = "&nbsp;";
	
	var ButtonFullOn = document.createElement("SPAN");
	ButtonFullOn.id = "btnFullScreenOn";
	ButtonFullOn.className = "buttonLink";
	ButtonFullOn.style.fontSize = "120%";
	ButtonFullOn.innerHTML = "<?php echo \E::get('obj_kernel_lang')->get('FULL_SCREEN'); ?>";
	google.maps.event.addDomListener(ButtonFullOn, "click", function() {
		map_full_screen(divMapName);
	});
	controlDiv.appendChild(ButtonFullOn);
	
	var ButtonFullOff = document.createElement("SPAN");
	ButtonFullOff.id = "btnFullScreenOff";
	ButtonFullOff.style.display = "none";
	ButtonFullOff.className = "buttonLink";
	ButtonFullOff.style.fontSize = "120%";
	ButtonFullOff.innerHTML = "<?php echo \E::get('obj_kernel_lang')->get('NORMAL_SCREEN'); ?>";
	google.maps.event.addDomListener(ButtonFullOff, "click", function() {
		map_normal_screen(divMapName);
	});
	controlDiv.appendChild(ButtonFullOff);
	
	if (use_marker){
		// Go to marker button in full screen
		var btnToMarker = document.createElement("SPAN");
		btnToMarker.id = "btnToMarker";
		// btnToMarker.style.display = "none";
		btnToMarker.className = "buttonLink";
		btnToMarker.style.fontSize = "120%";
		btnToMarker.innerHTML = "<?php echo \E::get('obj_kernel_lang')->get('GO_TO_MARKER'); ?>";
		google.maps.event.addDomListener(btnToMarker, "click", function() { goMarker(); } );
		controlDiv.appendChild(whitespace);
		controlDiv.appendChild(btnToMarker);
	}
}

function map_full_screen(divMapName){
	mapFullScreenOnOff(divMapName, 1);
	// if (document.getElementById("btnToMarker")){
		// document.getElementById("btnToMarker").style.display = "inline-block";
	// }
	moveSearchBox("map");
}

function map_normal_screen(divMapName){
	mapFullScreenOnOff(divMapName, 0);
	// if (document.getElementById("btnToMarker")){
		// document.getElementById("btnToMarker").style.display = "none";
	// }
	moveSearchBox("form");
}

function moveSearchBox( target ){
	divSearch = document.getElementById("google_map_seach_box");
	var browserName=navigator.appName;
	
	if (divSearch){
		if (target.toUpperCase() == "MAP"){
			var vSearchBox = document.createElement("DIV");
			
			vSearchBox.id = "divMapSearchBox";
			vSearchBox.style.border = "thin solid #000000";
			vSearchBox.style.backgroundColor = "#FFFFFF";
			vSearchBox.appendChild(divSearch);
			
			map.controls[google.maps.ControlPosition.RIGHT].push(vSearchBox);
			
			if (browserName == "Microsoft Internet Explorer"){
				divSearch.style.width = "1px";
			}
		}else{
			document.getElementById("divSearchContainer").appendChild(divSearch);
			map.controls[google.maps.ControlPosition.RIGHT].clear();
			
			if (browserName == "Microsoft Internet Explorer"){
				divSearch.style.width = "";
			}
		}
	}
}

var vMapFullScreen = false;
function mapFullScreenOnOff(divMapName, val){
	objMap = document.getElementById(divMapName);
	var browserName=navigator.appName;
	
	if (val == 1){
		// Map in full screen
		vMapFullScreen = true;
		objMap.style.border = "thin solid #000000";
		objMap.style.zIndex = "999";
		if (browserName == "Microsoft Internet Explorer"){
			objMap.style.position = "absolute";
			objMap.className = "mapScreenFull";
			objMap.style.width = document.body.clientWidth;
			objMap.style.height = document.body.clientHeight;
			window.onresize = function(){
				objMap = document.getElementById(divMapName);
				objMap.style.width = document.body.clientWidth;
				objMap.style.height = document.body.clientHeight;
			}
		}else{
			objMap.style.position = "fixed";
			objMap.style.top = 0;
			objMap.style.left = 0;
			objMap.style.width = "100%";
			objMap.style.height = "100%";
		}
		if (document.getElementById("btnFullScreenOff")){
			document.getElementById("btnFullScreenOff").style.display = "inline-block";
		}
		if (document.getElementById("btnFullScreenOn")){
			document.getElementById("btnFullScreenOn").style.display = "none";
		}
	}else{
		// Map in normal screen
		vMapFullScreen = false;
		objMap.style.border = "thin solid #000000";
		objMap.style.zIndex = "999";
		objMap.style.position = "relative";
		objMap.style.width = divMapWidth;
		objMap.style.height = divMapHeight;
		if (browserName == "Microsoft Internet Explorer"){
			objMap.className = "mapScreenNormal";
		}else{
		}
		if (document.getElementById("btnFullScreenOn")){
			document.getElementById("btnFullScreenOn").style.display = "inline-block";
		}
		if (document.getElementById("btnFullScreenOff")){
			document.getElementById("btnFullScreenOff").style.display = "none";
		}
	}
	
	resizeMap();
	if (use_marker){
		goMarker();
	}
}

function updateInfoContent(){
	return "";
	// TO DO
}

function resizeMap(){
	google.maps.event.trigger(map, 'resize');
}

function setMarker(lat, lng){
	vTargetLocation = new google.maps.LatLng(lat, lng);
	marker.setPosition(vTargetLocation);
	
	vLat = lat;
	vLng = lng;
	
	updateInfoContent();
	if (showInfoWindow){
		infowindow.open(map, marker);
	}
}

function setMarkerMsg(location, msg){
	// TO DO
	// marker.setPosition(location);
	// vLat = location.lat();
	// vLng = location.lng();
	
	// vDisplayContent = '<br />'+location.toString();
	// vDisplayContent += '<br />'+msg;
	
	// infowindow.setContent(vDisplayContent);
	// if (showInfoWindow)
		// infowindow.open(map, marker);
}

function searchAddress( target, callbacks ){
	var query = target;
	
	if (query != ""){
		gLocalSearch.execute(query);
		if (callbacks != ""){
			gLocalSearch.setSearchCompleteCallback(null, function(){ eval(callbacks + "(gLocalSearch.results)"); });
		}
	}
}

function goHere(lat, lng){
	vTargetLocation = new google.maps.LatLng(lat, lng);
	map.setCenter(vTargetLocation);
}

function goMarker(){
	vMarkerLocation = marker.getPosition();
	map.setCenter(vMarkerLocation);
}

function getMarkerPosition(){
	return marker.getPosition();
}
</script>