<?php
////////////////////////////////////////////////////////////////
// PHP script made by PhangKY
// v1.0 - 11:43 AM 04/02/2009
////////////////////////////////////////////////////////////////

// --------------------------------------------------------------------------------
// LOAD GRADIENT FUNCTION
// --------------------------------------------------------------------------------
include 'gradient.php';

// --------------------------------------------------------------------------------
// CONFIG
// --------------------------------------------------------------------------------

// default value
$max = 100;
$total = 0;
$width = 80;
$height = 160;
$display_total = true;
$display_max = true;
$display_percentage = true; // when this is true, the $display_max and $display_total will be ignored.
$font_size = 5;

// --------------------------------------------------------------------------------
// INIT
// --------------------------------------------------------------------------------

// override with parameter
if (isset($_GET['m'])){
	if (is_numeric($_GET['m'])){
		$max = $_GET['m'];
	}
}
if (isset($_GET['t'])){
	if (is_numeric($_GET['t'])){
		$total = $_GET['t'];
	}
}
if (isset($_GET['w'])){
	if (is_numeric($_GET['w'])){
		$width = $_GET['w'];
	}
}
if (isset($_GET['h'])){
	if (is_numeric($_GET['h'])){
		$height = $_GET['h'];
	}
}

// init some important vars for calculation
$padding_left_right = ($width/2)-(($width-10)/2);
$padding_top_bottom = $width/4;
$ellipse_height = $width/4;

// create a blank image
//$image = imagecreate($width, $height);
//$image = imagecreatetruecolor($width, $height);
$image = imagecreate($width, $height);

// fill the background color
//$bg = imagecolorallocatealpha($image, 255, 255, 255, 0);
//$bg = imagecolorallocate($image, 0, 0, 0);
//$bg = imagecolorallocate($image, 235, 235, 235);
$bg = imagecolorallocatealpha($image, 255, 255, 255, 127);
//$bg = imagecolorallocatealpha($image)
imagefilledrectangle($image, 0, 0, $width, $height, $bg);
//imagecolortransparent($image, $bg);


// --------------------------------------------------------------------------------
// LAYER 1 : BACKGROUND BAR
// --------------------------------------------------------------------------------

$col_body = imagecolorallocate($image, 219, 219, 219);
$col_top = imagecolorallocate($image, 219, 219, 219);
$col_bottom = imagecolorallocate($image, 200, 200, 200);

// bottom
imagefilledellipse($image, $width/2, $height-$padding_top_bottom, $width-10, $ellipse_height, $col_bottom);

// body - original
//imagefilledrectangle ( $image, $padding_left_right, $padding_top_bottom, $width-$padding_left_right, $height-$padding_top_bottom, $col_body);

// body - new with gradient color
$w = $width-$padding_left_right-$padding_left_right+1;
$h = $height-($padding_top_bottom*2);
$bw = $width-$padding_left_right;
$bh = $height-$padding_top_bottom;
gradient($image,$h,$w,1,$bh,$bw,"C8C8C8","E4E4E4");

// top
imagefilledellipse($image, $width/2, $padding_top_bottom, $width-10, $ellipse_height, $col_top);

// --------------------------------------------------------------------------------
// LAYER 2: FOREGROUND BAR
// --------------------------------------------------------------------------------
//$total = 0;
if ($total>0){

	$percentage = $max / $total;
	$height_real = $height-($padding_top_bottom*2);
	$padding_top_extra = $height_real - ($height_real / $percentage);
	
	$col_top = imagecolorallocate($image, 0, 166, 0);
	$col_body = imagecolorallocate($image, 0, 225, 0);

	// bottom
	imagefilledellipse($image, $width/2, $height-$padding_top_bottom, $width-10, $ellipse_height, $col_body);

	// body - original
	//$darkgray = imagecolorallocate($image, 0, 210, 0);
	//imagefilledrectangle ( $image, $padding_left_right, $padding_top_bottom+$padding_top_extra, $width-$padding_left_right, $height-$padding_top_bottom, $col_body);
	
	// body - new with gradient color
	$w = $width-$padding_left_right-$padding_left_right+1;
	$h = $height-$padding_top_bottom-$padding_top_bottom-$padding_top_extra;
	$bw = $width-$padding_left_right;
	$bh = $height-$padding_top_bottom;
	gradient($image,$h,$w,1,$bh,$bw,"00E100","00AE00");
	
	// top
	imagefilledellipse($image, $width/2, $padding_top_bottom+$padding_top_extra, $width-10, $ellipse_height, $col_top);
	
	// redraw the top part of the background bar, in case the it is overriden.
	$col_top = imagecolorallocatealpha($image, 200, 200, 200, 75);
	imagefilledellipse($image, $width/2, $padding_top_bottom, $width-10, $ellipse_height, $col_top);
	
	// display some text
	if ($display_percentage){
		// display percentage (if needed)
		$lbl_total = round(($total / $max * 100), 2) . "%";
		$textcolor = imagecolorallocate($image, 0, 0, 0);
		imagestring($image, $font_size, (ceil($width/2))-($padding_left_right)-countPixelToMinus($lbl_total), $padding_top_extra+$padding_top_bottom/2, $lbl_total, $textcolor);
	}else{
		// display max (if needed)
		if ($display_max){
			$lbl_max = $max;
			$textcolor = imagecolorallocate($image, 0, 0, 0);
			imagestring($image, $font_size, (ceil($width/2))-($padding_left_right)-countPixelToMinus($lbl_max), floor($padding_top_bottom/2), $lbl_max, $textcolor);
		}
		// display total (if needed)
		if ($display_total){
			$lbl_total = $total;
			$textcolor = imagecolorallocate($image, 0, 0, 0);
			imagestring($image, $font_size, (ceil($width/2))-($padding_left_right)-countPixelToMinus($lbl_total), $padding_top_extra+$padding_top_bottom/2, $lbl_total, $textcolor);
		}
	}

}

// --------------------------------------------------------------------------------
// Functions
// --------------------------------------------------------------------------------
function countPixelToMinus( $pString ){
	global $font_size;
	$count = strlen ($pString);
	$pixelPerChar = $font_size;
	return floor(($pixelPerChar * $count) / 2 );
}

// --------------------------------------------------------------------------------
// Final fine tuning
// --------------------------------------------------------------------------------
imageantialias($image, true);
imagecolortransparent($image, $bg);
imageInterlace($image);

// --------------------------------------------------------------------------------
// output the picture
// --------------------------------------------------------------------------------

//header("Content-type: image/png");
//imagepng($image);
header("Content-type: image/gif");
imagegif($image);

imagedestroy($image);
?> 