<?php
function gradient($im,$height,$width,$step,$baseheight,$basewidth,$base,$end){

	// $im is passed as @$im for the image to draw it on
	// $height is the Height of the box to draw
	// $width is the width of the box to draw
	// $step is the steps to take, a step of 10 would change the colour every 10 pixels
	// $baseheight is where to place the bottom of the rectangle
	// $basewidth is the left side of the location for the rectangle
	// $base is the start colour in hex (ffffff)
	// $end is the colour to end at in hex (000000)

	// Break colours into RGB components
	sscanf($base, "%2x%2x%2x", $rbase, $gbase, $bbase);
	sscanf($end, "%2x%2x%2x", $rend, $gend, $bend);

	// Set the Variable to step to use height
	$varstep=$height;

	// Remove potential divide by 0 errors.
	if ($rbase==$rend) $rend = $rend -1;
	if ($gbase==$gend) $gend = $gend -1;
	if ($bbase==$bend) $bend = $bend -1;

	// Make sure the height is at least 1 pixel
	if ($varstep == 0) $varstep=1;

	// Set up step modifiers for each colour
	$rmod = ($rend - $rbase) /$varstep;
	$gmod = ($gend - $gbase) /$varstep;
	$bmod = ($bend - $bbase) /$varstep;

	// Serves no real purpose.
	$white=imagecolorallocate($im,255,255,255);

	// Loop for the height at a rate equal to the steps.
	for($i=1;$i<$varstep;$i=$i+$step+1){

		//Adjust the colours
		$clour1 = ($i*$rmod)+$rbase;
		$clour2 = ($i*$gmod)+$gbase;
		$clour3 = ($i*$bmod)+$bbase;
		$col=imagecolorallocate($im,$clour1,$clour2,$clour3);

		//Paint the rectangle at current colour.
		imagefilledrectangle($im,$basewidth-$width+1,$baseheight-$i,$basewidth,$baseheight-$i+$step,$col);
	}


	// Return the colour
	return(@$im);

}
?>