<?php
/* 2013-09-25: Modified by Tan for pie chart that total don't have any legend and label */

////////////////////////////////////////////////////////////////
// PHP script made by Rasmus - http://www.peters1.dk //
////////////////////////////////////////////////////////////////

$width = isset($_GET["width"]) ? $_GET["width"] : 90; // width of the chart image
$background_color = 'FFFFFF'; // background-color of the chart...
$text_color = '000000'; // text-color.
$colors = isset($_GET["colors"]) ? explode(",", $_GET["colors"]) : ""; // 2013-06-27 Added by Tan: customise color of slices by parameter
if (!isset($colors) || $colors==""){
	// colors of the slices.
	$colors = array('FFDECE', 'FF0000', 'FFFF00', '80FF00', '42C1FF', 'FF80FF', 'AFAFD8', '00FF00', '7F99B2','C6BE8C', 'F7EFC6', '003366'); 
}
$shadow_height = 16; // Height on shadown.
$shadow_dark = true; // true = darker shadow, false = lighter shadow...

// DON'T CHANGE ANYTHING BELOW THIS LINE...

$data = $_GET["data"];

$height = isset($_GET["height"]) ? $_GET["height"] : $width/2;  // height of the chart image
$data = explode('*',$data);


$img = ImageCreateTrueColor($width, $height+ceil($shadow_height));

ImageFill($img, 0, 0, colorHex($img, $background_color));

foreach ($colors as $colorkode) 
{
	$fill_color[] = colorHex($img, $colorkode);
	$shadow_color[] = colorHexshadow($img, $colorkode, $shadow_dark);
}

$centerX = round($width/2);
$centerY = round($height/2);
$diameterX = $width-4;
$diameterY = $height-4;

$data_sum = array_sum($data);

$start = 270;
$value = 0;
$value_counter = 0;
for ($i = 0; $i < count($data); $i++) 
{
	if($data[$i] != '0'){
		$value += $data[$i];
		$end = ceil(($value/$data_sum)*360) + 270;
		$slice[] = array($start, $end, $shadow_color[$value_counter % count($shadow_color)], $fill_color[$value_counter % count($fill_color)]);
		$start = $end;
	}
	$value_counter++;
}

for ($i=$centerY+$shadow_height; $i>$centerY; $i--) 
{
	for ($j = 0; $j < count($slice); $j++)
	{
    if($slice[$j][0]!=$slice[$j][1]){
      ImageFilledArc($img, $centerX, $i, $diameterX, $diameterY, $slice[$j][0], $slice[$j][1], $slice[$j][2], IMG_ARC_PIE);
    }
	}
}	

for ($j = 0; $j < count($slice); $j++)
{
  if($slice[$j][0]!=$slice[$j][1]){
    ImageFilledArc($img, $centerX, $centerY, $diameterX, $diameterY, $slice[$j][0], $slice[$j][1], $slice[$j][3], IMG_ARC_PIE);
  }
}

OutputImage($img);
ImageDestroy($img);


function colorHex($img, $HexColorString) 
{
		$R = hexdec(substr($HexColorString, 0, 2));
		$G = hexdec(substr($HexColorString, 2, 2));
		$B = hexdec(substr($HexColorString, 4, 2));
		return ImageColorAllocate($img, $R, $G, $B);
}

function colorHexshadow($img, $HexColorString, $mork) 
{
	$R = hexdec(substr($HexColorString, 0, 2));
	$G = hexdec(substr($HexColorString, 2, 2));
	$B = hexdec(substr($HexColorString, 4, 2));

	if ($mork)
	{
		($R > 99) ? $R -= 100 : $R = 0;
		($G > 99) ? $G -= 100 : $G = 0;
		($B > 99) ? $B -= 100 : $B = 0;
	}
	else
	{
		($R < 220) ? $R += 35 : $R = 255;
		($G < 220) ? $G += 35 : $G = 255;
		($B < 220) ? $B += 35 : $B = 255;				
	}			
	
	return ImageColorAllocate($img, $R, $G, $B);
}

function OutputImage($img) 
{
header("Content-type: image/png");
imagepng($img);
}

?>